{$A+,B-,E-,F-,G-,I-,N-,O-,V-,X- }

{$IFDEF DEBUG }
  {$R+,S+ }
{$ELSE }
  {$D-,L-,R-,S- }
{$ENDIF }

Unit forsave;

interface

uses Dos,VdtDisp,VdtTools,Colors,Stringer,RamDisk2,Video60,EmulM2,DirCon,InterCon;


Function  CompilVrai( Var RF : RamFile; Var M : MemPg_Rec; Reel : boolean) : boolean;

procedure OpenWindDiskOp;
procedure WriteDiskOp( texte : string; posY : byte);
function  ForceExt( name : string; ext : string) : string;
function  ForceNoExt( name : string; ext : string) : string;

Procedure CreatBackUp( name : String );
function  SaveSingleVideotex( var M : MemPg_Rec; Path,name : string) : boolean;
function  SaveSingleMem( var M : MemPg_Rec; name : string) : boolean;
function  GestFileError( ioerror : word) : boolean;

Procedure ChargeParam;
procedure AjouteAntiSlash( var s : string; max : byte );

Function  CreatBack( Ram : PVDispRam; DRCS : PVDispRamDRCS;
                     Var Back : String; CheckError : Boolean ) : Boolean;
Function  CreatBackGround( Ram : PVDispRam; DRCS : PVDispRamDRCS;
                           Var M : MemPg_Rec; CheckError : Boolean ) : Boolean;

function  GestLoad( Var f : File; var M : MemPg_Rec ) : boolean;
function  CloseFile( Var f : File ) : boolean;

implementation

{$I PARAM.PAS }


Procedure EmulStr( Var Em : EmulRec; texte : String );
Var i : Byte;
    r : Word;
Begin
 For i := 1 To Length(texte) Do r := Emul(Em,texte[i]);
End;

Procedure EmulThat( Var Em : EmulRec; Var p; Lg : Word );
Type That = Array[1..60000] Of Char;
Var i : Word;
    t : That Absolute p;
    r : Word;
Begin
 For i := 1 To Lg Do r := Emul(Em,t[i]);
End;

Procedure MoveRamEmul( Var Ram : RamFile; Var Em : EmulRec; Var p; Lg : Word );
Begin
 Ram.Move(p,Lg);
 EmulThat(Em,p,Lg);
End;

Procedure WriteRamEmul( Var Ram : RamFile; Var Em : EmulRec; Texte : String );
Begin
 Ram.Move(Texte[1],Length(Texte));
 EmulThat(Em,Texte[1],Length(Texte));
End;


Procedure PutRamEmul( Var Ram : RamFile; Var Em : EmulRec; Data : Byte );
Var r : Word;
Begin
 Ram.Put(Data);
 r := Emul(Em,Char(Data));
End;


function ForceNoExt( name : string; ext : string) : string;
{  force seulement si aucunne extension n'existe pas  }
{  pas de correction elementaire si une extension existe  }
begin
  if Pos('.',name)<=0 then name := ForceExt(name,ext);
  ForceNoExt := name;
end;

function GestFileError( ioerror : word) : boolean;
var bidon : byte;
begin
  if ioerror = 0 then GestFileError := true {  pas d'erreur  }
  else
    begin
      GestFileError := false;
      bidon := GestWindError(2,ioerror,E_OK);
    end;
end;

{ *************** MAKE COMPILE ********************* }

procedure StartRouleau( Var Ram : RamFile; Var VD : VDispRec; Trans, Reel : boolean );
begin
  if Trans then
    if Reel then Ram.Write(MPRO2+'f'+char(4)+MPRO2+MSTART+MROULEAU)
    else Ram.Write(#0#0#0#0+MPRO2+MSTART+MROULEAU)
  else Ram.Write(MPRO2+MSTART+MROULEAU);

  VD.Cfg.DebCursor := FALSE;
  VD.Cfg.Scroll    := TRUE;
end;

procedure StopRouleau( Var Ram : RamFile; Var VD : VDispRec; Trans, Reel : boolean );
begin
  if Trans then
    if Reel then Ram.Write(MPRO2+'f'+char(4)+MPRO2+MSTOP+MROULEAU)
    else Ram.Write(#0#0#0#0+MPRO2+MSTOP+MROULEAU)
  else Ram.Write(MPRO2+MSTOP+MROULEAU);

  VD.Cfg.Scroll    := FALSE;
end;


function EmpileFileInf( Var Ram : RamFile; Var Em : EmulRec; name : string ) : boolean;
const Mx_lg = 1024;
type intermed_map = array[1..Mx_lg] of byte;
var io : word;
    Good : boolean;
    intermed : ^intermed_map;
    result : word;
    fichier : File;
    path : string;
    EmulFile : Boolean;
begin
  new(intermed);
  If (name<>'') And (name[1]='!') Then
   Begin
    Delete(name,1,1);
    EmulFile := FALSE;       { pas d'emulation }
   End
  Else EmulFile := TRUE;  { emulation }

  name := ForceNoExt(name,Cfg.Ext);
  WriteDiskOp('RECHERCHE DE '''+name+'''',2);
  Good := false;
  if name<>'' then
    begin
      path := FSearch(name,CFG.ChChain);
      if path='' then
        begin
          if GestFileError(2) then;
        end
      else
        begin
          WriteDiskOp('"'+Path+'"',2);
          assign(fichier,path);
          reset(fichier,1);
          io := ioresult;
          if GestFileError(io) then
            begin
              repeat
                BlockRead(fichier,intermed^,Mx_lg,result);
                io := ioresult;
                if io=0 then
                 Begin
                  Ram.Move(intermed^,result);
                  If EmulFile Then EmulThat(Em,intermed^,result);
                 End;
              until (io<>0) or (result<Mx_lg);
              Good := GestFileError(io);
              close(fichier);
              io := ioresult;
              if not(GestFileError(io)) then Good := false;
            end;
        end;
    end
  else Good := GestFileError(190);
  dispose(intermed);
  EmpileFileInf := Good;
end;


function EmpileChainInf( Var Ram : RamFile; Var Em : EmulRec; chainTxt : string ) : boolean;
{  retourne true si tout c'est bien passe  }
var index : word;
    tempo : word;
    GoodStat : boolean;
    name : string[12];
begin
  GoodStat := true;
  index := 1;
  OpenWindDiskOp;
  WriteDiskOp('CHAINAGE DE FICHIERS VIDEOTEX',1);
  while (index<=length(chainTxt)) and GoodStat do
    begin
      tempo := Pos('+',ChainTxt);
      if tempo<=0 then tempo := length(ChainTxt)+1
      else ChainTxt[tempo] := '\';
      name := copy(ChainTxt,index,tempo-index);
      GoodStat := EmpileFileInf(Ram,Em,name);
      index := tempo+1;
    end;
  PopZn;
  EmpileChainInf := GoodStat;
end;


Function EmpileFileBackInf( Var Em : EmulRec; name : string; CheckError : Boolean ) : boolean;
const Mx_lg = 1024;
type intermed_map = array[1..Mx_lg] of byte;
var io : word;
    Good : boolean;
    intermed : ^intermed_map;
    result : word;
    fichier : File;
    path : string;
begin
  If (name<>'') And (name[1]='!') Then
   Begin
    EmpileFileBackInf := TRUE; { pas d'emulation }
   End
  Else
   Begin  { emulation }

    new(intermed);

    name := ForceNoExt(name,Cfg.Ext);

    If CheckError Then WriteDiskOp('RECHERCHE DE '''+name+'''',2);

    Good := false;
    if name<>'' then
     begin
      path := FSearch(name,CFG.ChChain);
      if path<>'' then
       begin
        If CheckError Then WriteDiskOp('"'+Path+'"',2);

        assign(fichier,path);
        reset(fichier,1);
        io := ioresult;
        if (io=0) Or (CheckError And GestFileError(io)) then
         begin
          repeat
           BlockRead(fichier,intermed^,Mx_lg,result);
           io := ioresult;
           if io=0 then
            Begin
             EmulThat(Em,intermed^,result);
            End;
          until (io<>0) or (result<Mx_lg);
          Good := (io=0) Or (CheckError And GestFileError(io));
          close(fichier);
          io := IoResult;
         end;
       end
      Else
       If CheckError Then
        Begin
         If GestFileError(2) Then ;
        End;
     end;

    dispose(intermed);
    EmpileFileBackInf := Good;

   End;
end;


Function EmpileBackInf( Var Em : EmulRec; ChainTxt : string; CheckError : Boolean ) : boolean;
{  retourne true si tout c'est bien passe  }
var index : word;
    tempo : word;
    GoodStat : boolean;
    name : string[12];
begin
  GoodStat := true;
  index := 1;

  If CheckError Then
   Begin
    OpenWindDiskOp;
    WriteDiskOp('CREATION DU FOND DE FICHIERS VIDEOTEX',1);
   End;

  while (index<=length(chainTxt)) and GoodStat do
    begin
      tempo := Pos('+',ChainTxt);
      if tempo<=0 then tempo := length(ChainTxt)+1
      else ChainTxt[tempo] := '\';
      name := copy(ChainTxt,index,tempo-index);
      GoodStat := EmpileFileBackInf(Em,name,CheckError);
      index := tempo+1;
    end;

  If CheckError Then PopZn;

  EmpileBackInf := GoodStat;
end;


Function MakeBack( Var Em : EmulRec; Backtxt : String; CheckError : Boolean ) : boolean;
Var Status : Boolean;
Begin
 if Length(BackTxt)>0 then status := EmpileBackInf(Em,BackTxt,CheckError)
 else status := true;

 MakeBack := status;
End;


function MakeIntro( Var Ram : RamFile; Var Em : EmulRec; var M : MemPg_Rec ) : boolean;
{  retourne si les operations de chainage ce sont bien produite  }
var status : boolean;
    t      : string;
    EmulStr: Boolean;
begin
  if M.param.LongChain<>0 then status := EmpileChainInf(Ram,Em,M.Chain)
  else status := true;
  if status then
    begin
      { introduire le code 1 !!! }
      t := M.Code1;
      if TradString(t,EmulStr)=0 then
       If EmulStr Then MoveRamEmul(Ram,Em,t[1],Length(t))
       Else Ram.Move(t[1],length(t)); { envoi le code... }
      if M.param.IntroCur<>0 then
        if M.Param.IntroCur=1 then
         Begin
          If Not(Em.Rdy.CurOFFON) Or
             Not(Em.Stat.CurOn) Then PutRamEmul(Ram,Em,17);
         End
        else
         Begin
          If Not(Em.Rdy.CurOFFON) Or
             Em.Stat.CurOn Then PutRamEmul(Ram,Em,20);
         End;
      if M.Param.VideLnZero then WriteRamEmul(Ram,Em,#31'@A'#24);
      if M.Param.VideEcran then PutRamEmul(Ram,Em,12);
    end;
  MakeIntro := status;
end;

procedure MakeConclu( Var Ram : RamFile; Var Em : EmulRec; var M : MemPg_Rec );
  procedure EnCommun;
  begin
    if (M.param.PPanel and 7)<>7 then
      begin
        WriteRamEmul(Ram,Em,#27+char(64+couleur[M.param.PPanel and 7]));
      end;
    if (M.param.PPanel and 512)=0 then WriteRamEmul(Ram,Em,#27#72);
  end;
var t       : string;
    EmulStr : Boolean;
begin
  with M.param do
    begin
      if PlaceCur then
        begin
          WriteRamEmul(Ram,Em,#31+char(65+PLigne)+char(65+PColonne));
          if (PPanel and Graphik)=0 then
            begin {  texte  }
  EnCommun;
  if (PPanel and 192)<>0 then WriteRamEmul(Ram,Em,#27+char(76+ReadAtt(PPanel,2)));
  if (PPanel and 256)<>0 then WriteRamEmul(Ram,Em,#27#93);
            end
          else
            begin {  graphik  }
  PutRamEmul(Ram,Em,14);
  EnCommun;
  if (PPanel and 56)<>0 then
    WriteRamEmul(Ram,Em,#27+char(80+couleur[ReadAtt(PPanel,1)]));
  if (PPanel and 1024)<>0 then WriteRamEmul(Ram,Em,#27#90);
            end;
        end;
      if ConcluCur<>0 then
        if ConcluCur = 1 then
         Begin { allumer le cur ? }
          If (IntroCur=2) Or ((IntroCur=0) And
             Not(Em.Rdy.CurOFFON And Em.Stat.CurON)) Then
                PutRamEmul(Ram,Em,17); { allume }
          { sinon pas la peine... c'est dj fait }
         End
        else
         Begin { teindre curseur }
          If (IntroCur=1) Or ((IntroCur=0) And
             Not(Em.Rdy.CurOFFON And Not(Em.Stat.CurON))) Then
                PutRamEmul(Ram,Em,20); { teind ... }
          { sinon pas la peine... c'est dj fait }
         End;
      { introduire le code 2 !!! }
      t := M.Code2;
      if TradString(t,EmulStr)=0 then
        If EmulStr Then MoveRamEmul(Ram,Em,t[1],length(t))  { envoi le code... }
        Else Ram.Move(t[1],length(t));
    end;
end;


Function CompilVrai( Var RF : RamFile; Var M : MemPg_Rec; Reel : boolean) : boolean;
Const VDCfg : VDispCfg = (
        CSI          : FALSE;
        OptInvGrp    : FALSE;
        OptInvTxt    : FALSE;
        OptRepet     : TRUE;
        xRep         : FALSE;
        ComplAsSpace : FALSE;
        ForceDelGrp  : FALSE;
        ForceDelTxt  : FALSE;
        VideAsSpace  : FALSE;
        OptWithCan   : TRUE;
        OptSpclGrp   : TRUE;
        OptSpclTxt   : FALSE;
        C15Clr       : FALSE;
        OptMem       : OM_Nothing;
        DebCursor    : FALSE;
        OptNilDRCS   : TRUE;
        NoCR         : FALSE;
        Scroll       : FALSE
       );

var s   : string;
    pos : word;
    VD  : VDispRec;
    Ram : PVDispRam;
    DRCS: PVDispRamDRCS;
    Em  : EmulRec;
    i   : word;
    Inverse : boolean;
    RolOn   : Boolean;
    ZZ      : Boolean;

  procedure Trans( xi, yi : Byte );
  begin
    TransCode(VD,xi,yi,M.Ram[yi,xi].Car,M.Ram[yi,xi].Att,s);
    RF.Write(s);
  end;

  procedure TransX( yi : Byte );
  var xi : word;
  begin
    if Inverse then
      for xi := ScreenLong-1 downto 0 do Trans(xi,yi)
    else for xi := 0 to ScreenLong-1 do Trans(xi,yi);
    if ZZ then Inverse := not(Inverse);
  end;

  procedure TransY( xi : Byte );
  var yi : word;
  begin
    if Inverse then
      for yi := ScreenHigh-1 downto 1 do Trans(xi,yi)
    else for yi := 1 to ScreenHigh-1 do Trans(xi,yi);
    if ZZ then Inverse := not(Inverse);
  end;

  procedure TransScrollUp( xi, yi : Byte );
  begin
    TransCode(VD,xi,ScreenHigh-1,M.Ram[yi,xi].Car,M.Ram[yi,xi].Att,s);
    RF.Write(s);
  end;

  Procedure TransScrollUpX( yi : Byte );
  Var xi : Byte;
  Begin
   If RolOn Then
    Begin
     If VD.NextLn>0 Then
      Begin

       FlushTrans(VD,s);
       RF.Write(s);
       If VD.UseCAN Then
        Begin
         TransCodeScrollUp(VD,s);
         RF.Write(s);
        End;

      End
     Else
      Begin
       TransCodeScrollUp(VD,s);
       RF.Write(s);
      End;
    End
   Else RolOn := TRUE;

   If Inverse Then
    For xi := ScreenLong-1 Downto 0 Do TransScrollUp(xi,yi)
   Else For xi := 0 to ScreenLong-1 do TransScrollUp(xi,yi);

   If ZZ Then Inverse := not(Inverse);
  End;

  procedure TransScrollDown( xi, yi : Byte );
  begin
    TransCode(VD,xi,1,char(M.Ram[yi,xi].Car),M.Ram[yi,xi].Att,s);
    RF.Write(s);
  end;

  Procedure TransScrollDownX( yi : Byte );
  Var xi : Byte;
  Begin
   If RolOn Then
    Begin
     If VD.NextLn>0 Then
      Begin
       TransCodeScrollDown(VD,s);

       RF.Write(s);

       If Not(VD.UseCAN) Then
        Begin
         TransCodeScrollDown(VD,s);
         RF.Write(s);
        End;
      End
     Else
      Begin
       TransCodeScrollDown(VD,s);
       RF.Write(s);
      End;
    End
   Else RolOn := TRUE;

   If Inverse Then
    For xi := ScreenLong-1 Downto 0 Do TransScrollDown(xi,yi)
   Else For xi := 0 to ScreenLong-1 do TransScrollDown(xi,yi);

   If ZZ Then Inverse := not(Inverse);
  End;

var xi, yi : Byte;
    d : PVDispRamDRCS;
begin
 New(Ram);
 ClearRam(Ram);

 New(DRCS);
 ClearRamDRCS(DRCS);

 InitVD(VD,Ram,DRCS,@M.DRCS);
 VD.Cfg := VDCfg;

 VD.Cfg.CSI          := M.Param.CSI;
 VD.Cfg.OptRepet     := M.Param.OptRepet;
 VD.Cfg.ComplAsSpace := M.Param.ComplAsSpace;
 VD.Cfg.VideAsSpace  := Not(M.Param.SauteVide);

 ZZ      := M.Param.ZigZag;
 Inverse := M.Param.Inverse;

 VD.Cfg.OptInvGrp    := M.Param.OptInvGrp;
 VD.Cfg.OptInvTxt    := M.Param.OptInvTxt;
 VD.Cfg.xRep         := M.Param.xRep;
 VD.Cfg.ForceDelGrp  := M.Param.ForceDelGrp;
 VD.Cfg.ForceDelTxt  := M.Param.ForceDelTxt;
 VD.Cfg.C15Clr       := M.Param.C15Clr;
 VD.Cfg.OptMem       := M.Param.OptMem;
 VD.Cfg.DebCursor    := M.Param.DebCursor;
 VD.Cfg.NoCR         := M.Param.NoCR;

 If Cfg.EmulChDRCS Then d := DRCS Else d := NIL;

 InitEmul(Em,Ram,d);
 Em.Cfg := Cfg.Emul;

 If MakeBack(Em,M.Back,TRUE) Then
  Begin
   InitEmul(Em,Ram,d);
   Em.Cfg := Cfg.Emul;     { Normal: la construction du fond n'influence pas ! }

   If MakeIntro(RF,Em,M) then
    Begin
     If (Em.Situ.CurPos) And
        (Not(M.Param.ForceCur) Or M.Param.VideLnZero Or M.Param.VideEcran) Then  { la position est connu }
      Begin
       VD.Cur.X   := Em.Situ.X;
       VD.Cur.Y   := Em.Situ.Y;
       VD.Cur.Att := Em.Situ.Att;
       VD.Cur.Rdy := TRUE;
      End;  { sinon, la position du curseur reste a fixer }

     RolOn      := Not(M.Param.VideEcran);

     If Not(Em.Stat.MdPage) Then VD.Cfg.DebCursor := FALSE;

     case M.Param.ModeAff of
       M_BasHaut : for yi := ScreenHigh-1 downto 1 do TransX(yi);

       M_Montant :
        Begin
         FixScrollUpLine(VD,s); RF.Write(s);

         If Em.Stat.MdPage Then StartRouleau(RF,VD,Cfg.ModMntel,Reel);

         For yi := 1 To ScreenHigh-1 Do TransScrollUpX(yi);
         If (VD.NextLn=0) Or (VD.UseCan) Then
          Begin
           FlushTrans(VD,s);
           RF.Write(s);
          End;
         StopRouleau(RF,VD,Cfg.ModMntel,Reel);
        End;

       M_Descendant :
        Begin
         FixScrollDownLine(VD,s); RF.Write(s);

         If Em.Stat.MdPage Then StartRouleau(RF,VD,Cfg.ModMntel,Reel);

         For yi := ScreenHigh-1 Downto 1 Do TransScrollDownX(yi);
         StopRouleau(RF,VD,Cfg.ModMntel,Reel);
        End;

       M_GaucheDroite : for xi := 0 to ScreenLong-1 do TransY(xi);

       M_DroiteGauche : for xi := ScreenLong-1 downto 0 do TransY(xi);

     else { Normal: M_HautBas }
       for yi := 1 to ScreenHigh-1 do TransX(yi);
     end;

     FlushTrans(VD,s);
     RF.Write(s);

     ResetTrans(VD,s);
     RF.Write(s);

     MakeConclu(RF,Em,M);
     CompilVrai := TRUE;

    End
   Else CompilVrai := FALSE;
  End
 Else CompilVrai := FALSE;

 Dispose(DRCS);
 Dispose(Ram);
End;


{ Initialise la RAM video (et DRCS ?) }

Function CreatBack( Ram : PVDispRam; DRCS : PVDispRamDRCS;
                    Var Back : String; CheckError : Boolean ) : Boolean;
Var d  : PVDispRamDRCS;
    Em : EmulRec;
Begin
 ClearRam(Ram);
 ClearRamDRCS(DRCS);

 If Cfg.EmulChDRCS Then d := DRCS Else d := NIL;

 InitEmul(Em,Ram,d);
 Em.Cfg := Cfg.Emul;

 CreatBack := MakeBack(Em,Back,CheckError);
End;




{ Initialise la RAM video (et DRCS ?) }

Function CreatBackGround( Ram : PVDispRam; DRCS : PVDispRamDRCS;
                          Var M : MemPg_Rec; CheckError : Boolean ) : Boolean;
Var d  : PVDispRamDRCS;
    Em : EmulRec;
    t  : String;
    Status : Boolean;
    CanEmul : Boolean;
    r  : Word;
Begin
 Status := CreatBack(Ram,DRCS,M.Back,CheckError);

 If Status Then
  Begin

   If Cfg.EmulChDRCS Then d := DRCS Else d := NIL;

   InitEmul(Em,Ram,d);
   Em.Cfg := Cfg.Emul;

   Status := MakeBack(Em,M.Chain,CheckError);

   If Status Then
    Begin
     t := M.Code1;
     If (TradString(t,CanEmul)=0) And CanEmul Then
      Begin
       EmulStr(Em,t);
      End;

     If M.Param.VideLnZero Then EmulStr(Em,#31'@A'#24);
     If M.Param.VideEcran Then r := Emul(Em,#12);

    End;
  End;

 CreatBackGround := Status;
End;


{ ********************* TODISK **************************** }

const
     FileVer = 0; {  version de travail  }

     BPRIVE      = 0; {  code identifiant block  }
     BIMAGE      = 1;
     BPANEL      = 2;
     BPARAMETRES = 3;
     BCHAINAGE   = 4;
     BCODE1      = 5;
     BCODE2      = 6;
     BDRCS       = 7;
     BBACK       = 8;

     REPDRCS     = $DB;    { Code compressant DRCS }

(*
Var  Fichier     : File;
     LongFichier : LongInt;
*)

const Zncs : Zn_Rec = (x:5; y:7; lg:70; ht:4 );
procedure OpenWindDiskOp;
begin
  PushZn(Zncs);
  ClrZn(Zncs,CWind);
  CCdrZn(Zncs,CDRNORM,CCadre);
end;

procedure WriteDiskOp( texte : string; posY : byte);
begin
  WrtScr(CentreString(texte,ZnCS.lg-2,32),
         ZnCS.X+1,ZnCS.Y+posY,FWind+TNet);
end;

function ForceExt( name : string; ext : string) : string;
{  ajoute ou change l'extension du nom fichier  }
{  correction elementaire effectue  }
{  un nom vide retourne un nom vide!  }
var tempo : byte;
begin
  KillData(name,32); {  vire les espaces  }
  KillData(ext,32);
  tempo := Pos('.',name);
  if tempo>0 then name := copy(name,1,tempo-1); {  vire l'extension  }
  Tronque(name,8);
  Tronque(ext,3);
  if name<>'' then name := name+'.'+ext;
  ForceExt := name;
end;

{ ************************ }

Procedure SeekAdd( Var f : File; num : Longint );
Begin
 Seek(f,FilePos(f)+num);
End;


Procedure SeekSub( Var f : File; num : Longint );
Begin
 num := FilePos(f)-num;
 if num<0 then num := 0;
 Seek(f,num);
End;


(*
Procedure CheckError;
Var io : Word;
Begin
 io := ioresult;
 if io<>0 then
  begin
   DriveAbandon := true;
   DriveError := io;
  end;
End;
*)

function CloseFile( Var f : File ) : boolean;
var io : word;
begin
  close(f);
  io := ioresult;
  CloseFile := GestFileError(io);
end;

Const DTI_Id   : Array[1..4] Of Char = 'dti'#26;

      DTI_Deb  : Array[1..3] Of Byte = (FileVer,0,0);

procedure SaveEnTete( Var f : File );
begin
  {  identifiant de base  }
  BlockWrite(f,DTI_Id,SizeOf(DTI_Id));
  BlockWrite(f,DTI_Deb,SizeOf(DTI_Deb));
end;

procedure SaveBlockImage( Var f : File; var M : MemPg_Rec );

function SaveCompact : word;
var NbreRep : byte;
    L       : VDispRamEl;
    w       : VDispRamEl;
    long    : word;

    Buf     : Array[1..256] Of Byte;
    iBuf    : Word;

  Procedure FlushBuf;
  Begin
   If iBuf>0 Then
    Begin
     BlockWrite(f,Buf,iBuf);
     iBuf := 0;
    End;
  End;

  Procedure PutByte( n : Byte );
  Begin
   Inc(iBuf);
   Buf[iBuf] := n;
   If iBuf>=SizeOf(Buf) Then FlushBuf;
  End;

  procedure Place0;
  begin
    PutByte(1);
    PutByte(NbreRep);
    Inc(long,2);
    NbreRep := 0;
  end;

  procedure Place;
  begin
    PutByte(2);
    PutByte(NbreRep);
    Inc(long,2);
    NbreRep := 0;
  end;

Var iX : Byte;
    iY : Byte;
begin
  iBuf    := 0;

  NbreRep := 0;
  long    := 0;
  L.Car   := #0;
  L.att   := 0;

  For iY := 1 To ScreenHigh-1 Do
   For iX := 0 To ScreenLong-1 Do
    Begin

     w := M.Ram[iY,iX];
     if L.Car=#0 then
       begin
         if w.Car=#0 then
           begin
             Inc(NbreRep);
             if NbreRep=255 then Place0;
           end
         else
           begin
             if NbreRep<>0 then Place0;
             PutByte(Byte(w.Car));
             PutByte(Lo(w.att));
             PutByte(Hi(w.att));
             Inc(long,3);
           end;
       end
     else
       if (L.Car=w.Car) and (L.att=w.att) then
         begin
           Inc(NbreRep);
           if NbreRep=255 then Place;
         end
       else
         begin
           if NbreRep<>0 then Place;
           if w.Car<>#0 then
             begin
               PutByte(Byte(w.Car));
               PutByte(Lo(w.att));
               PutByte(Hi(w.att));
               Inc(long,3);
             end
           else Inc(NbreRep);
         end;
     L := w;
    End;


  if NbreRep<>0 then
    if L.Car=#0 then Place0 else Place;

  FlushBuf;

  SaveCompact := long;
end;

Const BasicDeb : Array[1..7] Of Byte = (
         BIMAGE,     {  sauvegarde compact  }
         0,          {  on ne connait pas encore la longueur du block!  }
         0,          {  idem (Hi) }
         1,          {  1 image  }
         2,          {  type d'organisation : COMPACT  }
         0,          {  --- on connaitra l'info plus tard  }
         0           {  idem (Hi) }
        );

var index : word;
begin
  BlockWrite(f,BasicDeb,SizeOf(BasicDeb));
  {  image  }
  index := SaveCompact; {  retourne la longueur  }

  SeekSub(f,index+2+1+1+2); {  back!  }
  Inc(Index,4);
  BlockWrite(f,Index,SizeOf(Index));    {  longueur du block  }

  SeekAdd(f,2);
  Dec(Index,4);
  BlockWrite(f,Index,SizeOf(Index));    {  longueur image  }

  SeekAdd(f,index); {  replace l'ecriture sur disk  }
end;


procedure SaveBlock( Var f : File; var point; size : word);
begin
 If Size>0 Then
  Begin
   BlockWrite(f,point,Size);
  End;
end;


{ Sauvegarde en compressant }

Function SaveBlockCompress( Var f : File; var p; Size : Word; Compress : Byte ) : Word;
Type Surf = Array[0..60000] Of Byte;
Var s       : Surf Absolute p;

    Buf     : Array[1..256] Of Byte;
    iBuf    : Word;

    Long    : Word;
    NRep    : Byte;
    Last    : Byte;

  Procedure FlushBuf;
  Begin
   If iBuf>0 Then
    Begin
     BlockWrite(f,Buf,iBuf);
     iBuf := 0;
    End;
  End;

  Procedure PutByte( n : Byte );
  Begin
   Inc(iBuf);
   Buf[iBuf] := n;
   If iBuf>=SizeOf(Buf) Then FlushBuf;
  End;


  Procedure PlaceRep;
  Begin
   PutByte(Compress);
   PutByte(NRep);
   PutByte(Last);
   Inc(Long,3);

   NRep := 0;
  End;


  Procedure FlushRep;
  Begin
   If NRep>0 Then
    Begin
     If (Last=Compress) Or (NRep>2) Then PlaceRep
     Else
      Begin
       While NRep>0 Do
        Begin
         PutByte(Last);
         Dec(NRep);
         Inc(Long);
        End;
      End;
    End;
  End;


Var i : Word;
    d : Byte;
Begin
 iBuf := 0;

 Long := 0;
 NRep := 0;


 i := 0;
 While i<Size Do
  Begin
   d := s[i];

   If (NRep=0) Or (d=Last) Then
    Begin  { reptition }
     Last := d;
     Inc(NRep);
     If NRep=255 Then PlaceRep;
    End
   Else
    Begin
     FlushRep;
     Last := d;
     NRep := 1;
    End;

   Inc(i);
  End;

 FlushRep;

 FlushBuf;

 SaveBlockCompress := Long;
End;


procedure SaveBPANEL( Var f : File );
  function WordPanelActif : word;
  var index : byte;
      tempo : word;
  begin
    tempo := 0;
    for index := NbreAtt-1 downto 0 do
      begin
        tempo := tempo shl 1;
        if AttActif[index] then tempo := tempo or 1;
      end;
    WordPanelActif := tempo;
  end;
Const BasicDeb : Array[1..3] Of Byte = (
        BPANEL,
        SizeOf(PB),      { longueur }
        0                { toujours 0 }
       );

begin {  SaveBPANEL  }
  SaveBlock(f,BasicDeb,SizeOf(BasicDeb));
  PB.PanelActif := WordPanelActif;
  SaveBlock(f,PB,SizeOf(PB));
end;

procedure SaveBPARAMETRES( Var f : File; var M : MemPg_Rec );
Const BasicDeb : Array[1..3] Of Byte = (
        BPARAMETRES,
        SizeOf(Param_map),    { longueur }
        0                     { toujours 0 }
       );
begin
  SaveBlock(f,BasicDeb,SizeOf(BasicDeb));
  SaveBlock(f,M.param,SizeOf(M.param));
end;

procedure SaveBCHAINAGE( Var f : File; var M : MemPg_Rec );
var long : word;
    h    : Byte;
begin
 If Length(M.Chain)>0 Then
  Begin
   h := BCHAINAGE;
   SaveBlock(f,h,SizeOf(h));
   long := length(M.Chain)+1;
   SaveBlock(f,long,SizeOf(long));  {  longueur minimun 1 , max : 256  }
   SaveBlock(f,M.Chain,long);
  End;
end;

procedure SaveBCODE1( Var f : File; var M : MemPg_Rec );
var long : word;
    h    : Byte;
begin
 If Length(M.Code1)>0 Then
  Begin
   h := BCODE1;
   SaveBlock(f,h,SizeOf(h));
   long := length(M.Code1)+1;
   SaveBlock(f,long,SizeOf(long)); {  longueur minimun 1 , max : 256  }
   SaveBlock(f,M.Code1,long);
  End;
end;

procedure SaveBCODE2( Var f : File; var M : MemPg_Rec );
var long : word;
    h    : Byte;
begin
 If Length(M.Code2)>0 Then
  Begin
   h := BCODE2;
   SaveBlock(f,h,SizeOf(h));
   long := length(M.Code2)+1;
   SaveBlock(f,long,SizeOf(long)); {  longueur minimun 1 , max : 256  }
   SaveBlock(f,M.Code2,long);
  End;
end;


procedure SaveBBACK( Var f : File; var M : MemPg_Rec );
var long : word;
    h    : Byte;
begin
 If Length(M.Back)>0 Then
  Begin
   h := BBACK;
   SaveBlock(f,h,SizeOf(h));
   long := length(M.Back)+1;
   SaveBlock(f,long,SizeOf(long)); {  longueur minimun 1 , max : 256  }
   SaveBlock(f,M.Back,long);
  End;
end;


Procedure _SaveBDRCS( Var f : File; Var M : MemPg_Rec );
Type Surf1880 = Array[0..1879] Of Byte;
Var lg : Word;
    su : ^Surf1880;
    h  : Byte;
    long : word;
Begin
 su := @M.DRCS;
 lg := 1880;
 While (lg>0) And (su^[lg-1]=0) Do Dec(lg);
 If lg>0 Then
  Begin  { il y a quelque chose  sauver }
   h := BDRCS;
   SaveBlock(f,h,SizeOf(h));
   long := 1+lg;
   SaveBlock(f,long,SizeOf(long));
   h := 0;
   SaveBlock(f,h,1);   { Type d'organisation 0 }
   SaveBlock(f,su^,lg);
  End;
End;


Procedure SaveBDRCS( Var f : File; Var M : MemPg_Rec );
Type Surf1880 = Array[0..1879] Of Byte;
Var lg : Word;
    su : ^Surf1880;
    h  : Byte;
    long : word;
    lgPos : Longint;
    save  : Longint;
Begin
 su := @M.DRCS;
 lg := 1880;
 While (lg>0) And (su^[lg-1]=0) Do Dec(lg);
 If lg>0 Then
  Begin  { il y a quelque chose  sauver }
   h := BDRCS;
   SaveBlock(f,h,SizeOf(h));

   lgPos := FilePos(f);     { position de la "longueur" }

   long := 0;                     { bidon }
   SaveBlock(f,long,SizeOf(long));  { ... }

   h := 1;
   SaveBlock(f,h,1);   { Type d'organisation 1 (Compress) }

   long := SaveBlockCompress(f,su^,lg,REPDRCS) +1 ;

   save := FilePos(f);

   Seek(f,lgPos);
   SaveBlock(f,long,SizeOf(long));  { la vrai longueur }

   Seek(f,save);
  End;
End;


function SaveSingleVideotex( var M : MemPg_Rec; Path,name : string) : boolean;
{  indique en sortie si l'operation c'est bien passe  }
const Mx_lg = 1024;
type intermed_map = array[1..Mx_lg] of byte;
var io : word;
    result : word;
    intermed : ^intermed_map;
    Good : boolean;
    Fichier : File;
    Ram : RamFile;
begin
  Good := false;
  if name<>'' then
    begin
      Ram.Init;
      if CompilVrai(Ram,M,TRUE) then
        begin
          assign(fichier,Path+name);
          rewrite(fichier,1);
          io := ioresult;
          if GestFileError(io) then
            begin
              new(intermed);
              repeat
                Ram.Read(intermed^,sizeof(intermed^),result);
                if result>0 then
                  begin
                    BlockWrite(fichier,intermed^,result,result);
                    io := ioresult;
                  end;
              until (result=0) or (io<>0);
              Good := GestFileError(io);
              dispose(intermed);
              close(fichier);
              io := ioresult;
              if not(GestFileError(io)) then Good := false;
            end;
        end;
      Ram.Done;
    end
  else Good := GestFileError(190);
  SaveSingleVideotex := Good;
end;


Procedure CreatBackUp( name : String );
Var Io : Word;
    f  : File;
Begin
 If Cfg.BackUp Then
  Begin
   Assign(f,Name);
   Reset(f,1);
   If IoResult=0 Then
    Begin  { Existe !!! }
     Close(f);
     Io := IoResult;       { Ignore ... }
     Assign(f,'_BACKUP_.DTI');
     Erase(f);             { supprime l'ancien "BackUp"... si existe! }
     Io := IoResult;       { Ignore ... }
     Assign(f,Name);
     Rename(f,'_BACKUP_.DTI');
     Io := IoResult;       { Ignore ... }
    End;
  End;
End;


function SaveSingleMem( var M : MemPg_Rec; name : string) : boolean;
{  indique en sortie si l'operation c'est bien passe  }
var io : word;
    status : boolean;
    f  : File;
begin
  if name<>'' then
    begin
      assign(f,name);
      rewrite(f,1);
      io := ioresult;
      if GestFileError(io) then
        begin
          SaveEnTete(f);
          SaveBlockImage(f,M); {  0=>FULL 1=>COMPIL0 2=>Compact  }
          SaveBPANEL(f);
          SaveBPARAMETRES(f,M);
          SaveBCHAINAGE(f,M);
          SaveBCODE1(f,M);
          SaveBCODE2(f,M);
          SaveBDRCS(f,M);
          SaveBBACK(f,M);
          Status := CloseFile(f);
        end
      else
        Status := false;
    end
  else
    status := GestFileError(190);
  SaveSingleMem := status;
end;


{ **** LOAD DTI ... **** }

function GetByte( Var f : File ) : byte;
var colector : byte;
begin
 BlockRead(f,colector,SizeOf(colector));
 GetByte := colector;
end;

function GetWord( Var f : File ) : word;
var colector : Word;
begin
 BlockRead(f,colector,SizeOf(colector));
 GetWord := colector;
end;


function LoadEnTete( Var f : File ) : boolean;
const EnTete1 : Array[1..4] Of Char = 'dti'#26;     {  nouveau!  }
      EnTete2 : Array[1..4] Of Char = #16#06#66#09; {  ancien!!  }
var buf   : Array[1..4] Of Char;
    r     : Word;
begin
  BlockRead(f,buf,SizeOf(buf),r);
  LoadEnTete := (r=4) And ((buf=Entete1) or (buf=Entete2));
end;

procedure LoadBIMAGE( Var f : File; var M : MemPg_Rec );

  procedure LoadFullSingleImage;
  var iY : Byte;
  begin
   For iY := 1 To ScreenHigh-1 Do
    Begin
     BlockRead(f,M.Ram[iY],SizeOf(M.Ram[iY]));
    End;
  End;


  procedure LoadCompil0SingleImage( long : word);
  var Rlong : word; {  longueur lu  }
      m_data : byte;
      tempo : byte;
      Jindex: Word;
      iX    : Byte;
      iY    : Byte;
      Buf   : Array[1..256] Of Byte;
      LBuf  : Word;
      iBuf  : Word;

      Function GetByte : Byte;
      Begin
       If iBuf=0 Then
        Begin
         BlockRead(f,Buf,SizeOf(Buf),LBuf);
         iBuf := 1;
        End;
       GetByte := Buf[iBuf];
       If iBuf>=SizeOf(Buf) Then iBuf := 0 Else Inc(iBuf);
      End;

      Function GetWord : Word;
      Type WordRec = Record Lo, Hi : Byte; End;
      Var tempo : Word;
      Begin
       WordRec(tempo).Lo := GetByte;
       WordRec(tempo).Hi := GetByte;
       GetWord := tempo;
      End;

  begin
    iBuf := 0;
    LBuf := 0;

    iX := 0;
    iY := 1;
    Rlong := 0;
    while (iY<ScreenHigh) and (Rlong<long) do
      begin
        m_data := GetByte;
        if m_data=1 then
          begin
            tempo := GetByte;
            for Jindex := 1 to tempo do
              begin
                M.Ram[iY,iX] := vierge;
                Inc(iX);
                If iX>=ScreenLong Then
                 Begin
                  Inc(iY);
                  iX := 0;
                 End;
              end;
            Inc(Rlong,2);
          end
        else
          begin
            with M.Ram[iY,iX] do
              begin
                Car  := Char(m_data);
                Att  := GetWord;
              end;
            Inc(iX);
            If iX>=ScreenLong Then
             Begin
              Inc(iY);
              iX := 0;
             End;
            Inc(Rlong,3);
          end;
      end;
    If iBuf>0 Then
     Begin
      SeekSub(f,(LBuf+1)-iBuf);
     End;

    if Rlong<long then SeekAdd(f,long-Rlong); {  en cas d'erreur !  }

    While  (iY<ScreenHigh) Do
     Begin
      While (iX<ScreenLong) Do
       Begin
        M.Ram[iY,iX] := vierge;
        Inc(iX);
       End;

      iX := 0;
      Inc(iY);
     End;
  end;

  procedure LoadCompact( long : word );
  var Rlong : word; {  longueur lu  }
      w     : VDispRamEl;
      tempo : byte;
      Jindex : word;
      L     : VDispRamEl;
      iX    : Byte;
      iY    : Byte;
      Buf   : Array[1..256] Of Byte;
      LBuf  : Word;
      iBuf  : Word;

      Function GetByte : Byte;
      Begin
       If iBuf=0 Then
        Begin
         BlockRead(f,Buf,SizeOf(Buf),LBuf);
         iBuf := 1;
        End;
       GetByte := Buf[iBuf];
       If iBuf>=SizeOf(Buf) Then iBuf := 0 Else Inc(iBuf);
      End;

      Function GetWord : Word;
      Type WordRec = Record Lo, Hi : Byte; End;
      Var tempo : Word;
      Begin
       WordRec(tempo).Lo := GetByte;
       WordRec(tempo).Hi := GetByte;
       GetWord := tempo;
      End;

  begin
    iBuf := 0;
    LBuf := 0;

    iX    := 0;
    iY    := 1;
    Rlong := 0;
    L     := Vierge;

    while (iY<ScreenHigh) and (Rlong<long) do
      begin
        w.Car := Char(GetByte);
        if w.Car=#1 then
          begin
            w := Vierge;
            tempo := GetByte;
            for Jindex := 1 to tempo do
              begin
                M.Ram[iY,iX] := vierge;
                Inc(iX);
                If iX>=ScreenLong Then
                 Begin
                  Inc(iY);
                  iX := 0;
                 End;
              end;
            Inc(Rlong,2);
          end
        else
          if w.Car=#2 then
            begin
              w.Car := L.Car; { et oui! }
              tempo := GetByte;
              for Jindex := 1 to tempo do
                begin
                  M.Ram[iY,iX] := L;
                  Inc(iX);
                  If iX>=ScreenLong Then
                   Begin
                    Inc(iY);
                    iX := 0;
                   End;
                end;
              Inc(Rlong,2);
            end
          else
            begin
              w.att := GetWord;
              M.Ram[iY,iX] := w;
              Inc(iX);
              If iX>=ScreenLong Then
               Begin
                Inc(iY);
                iX := 0;
               End;
              Inc(Rlong,3);
            end;
        L := w;
      end;

    If iBuf>0 Then
     Begin
      SeekSub(f,(LBuf+1)-iBuf);
     End;

    if Rlong<long then SeekAdd(f,long-Rlong); {  en cas d'erreur !  }

    While  (iY<ScreenHigh) Do
     Begin
      While (iX<ScreenLong) Do
       Begin
        M.Ram[iY,iX] := vierge;
        Inc(iX);
       End;

      iX := 0;
      Inc(iY);
     End;
  end;

var NbreImg : byte;
    TypeOrg : byte;
    long    : word;
begin
  NbreImg := GetByte(f); {  nbre d'image  }
  while (NbreImg>0) and GestFileError(IoResult) do
    begin
      TypeOrg := GetByte(f); {  type d'organisation image  }
      long := GetWord(f); {  longueur  }
      case TypeOrg of
        0 : begin {  type FULL  }
              LoadFullSingleImage;
            end;
        1 : begin {  type COMPILE 0  }
              LoadCompil0SingleImage(long);
            end;
        2 : begin {  type COMPACT  }
              LoadCompact(long);
            end;
      else SeekAdd(f,long);
      end;
      Dec(NbreImg);
    end;
end;


procedure LoadBlock( Var f : File; var point; size,long : word);
var limite : word;
begin
  if long<size then limite := long
  else limite := size;

  BlockRead(f,point,limite);

  if long>size then SeekAdd(f,long-size);
end;


Procedure LoadBlockCompress( Var f : File; var p; size,long : word; Compress : Byte );
Type Surf = Array[0..60000] Of Byte;
Var s     : Surf Absolute p;
    Buf   : Array[1..256] Of Byte;
    LBuf  : Word;
    iBuf  : Word;

 Function GetByte : Byte;
 Begin
  If iBuf=0 Then
   Begin
    BlockRead(f,Buf,SizeOf(Buf),LBuf);
    iBuf := 1;
   End;
  GetByte := Buf[iBuf];
  If iBuf>=SizeOf(Buf) Then iBuf := 0 Else Inc(iBuf);
 End;

Var lu     : Word;
    i      : Word;
    d      : Byte;
    How    : Byte;
Begin
 iBuf := 0;
 LBuf := 0;

 i := 0;
 lu := 0;

 While (lu<long) And (i<Size) Do
  Begin
   d := GetByte;
   Inc(lu);
   If d=Compress Then
    Begin
     If (lu+2<=long) Then
      Begin
       How := GetByte;  { nombre de rptition }
       d   := GetByte;  { quoi a repeter ? }
       Inc(lu,2);
       While (How>0) And (i<Size) Do
        Begin
         s[i] := d;
         Inc(i);
         Dec(How);
        End;
      End
     Else { ignore la fin qui est une erreur ... }
      Begin
       While (lu<long) Do
        Begin
         d := GetByte;
         Inc(lu);
        End;
      End;
    End
   Else
    Begin
     s[i] := d;
     Inc(i);
    End;
  End;

 If lu<long Then SeekAdd(f,Long-lu);   { si erreur ... }

 While (i<Size) Do
  Begin
   s[i] := 0;
   Inc(i);
  End;

End;

procedure LoadBPANEL( Var f : File; long : word);
  procedure RestorePanelActif(tempo : word);
  var index : byte;
  begin
    for index := 0 to NbreAtt-1 do
      begin
        AttActif[index] := ((tempo and 1)<>0);
        tempo := tempo shr 1;
      end;
  end;
begin {  LoadBPANEL  }
  LoadBlock(f,PB,SizeOf(PB),long);
  RestorePanelActif(PB.PanelActif);
end;


Procedure LoadBDRCS( Var f : File; Var M : MemPg_Rec; long : Word );
Var tp : Byte;
    r  : Word;
Begin
 ClearRamDRCS(@M.DRCS);
 BlockRead(f,tp,SizeOf(tp),r);
 If tp=0 Then
  Begin
   Dec(long);
   If long>0 Then
    Begin
     LoadBlock(f,M.DRCS,SizeOf(M.DRCS),long);
    End;
  End
 Else
  If tp=1 Then
   Begin
    Dec(Long);
    If Long>0 Then
     Begin
      LoadBlockCompress(f,M.DRCS,SizeOf(M.DRCS),long,REPDRCS);
     End;
   End
  Else SeekAdd(f,long-1);
End;


function GestLoad( Var f : File; var M : MemPg_Rec ) : boolean;
var version : byte;
    IDblock : byte;
    long    : word;
begin
  if LoadEnTete(f) then
    begin {  bonne en tete  }
      InitParametrage(M);
      version := GetByte(f);
      long    := GetWord(f);
      {  pour n'importe quel version, on saute le block  }
      SeekAdd(f,long);
      while (not(eof(f))) and GestFileError(IoResult) And
            Not(AbortRequest) do
        begin
          IDblock := GetByte(f);
          long    := GetWord(f);
          case IDblock of
            BIMAGE : LoadBIMAGE(f,M);
            BPANEL : if CFG.NbreMem=1 then LoadBPANEL(f,long)
                     else SeekAdd(f,long);
                     {  se comporte normalement s'il n'y a qu'une mmoire  }
                     {  sinon, on ignore le block BPANEL  }
            BPARAMETRES : LoadBlock(f,M.param,SizeOf(M.param),long);
            BCHAINAGE   : LoadBlock(f,M.Chain,SizeOf(M.Chain),long);
            BCODE1      : LoadBlock(f,M.Code1,SizeOf(M.Code1),long);
            BCODE2      : LoadBlock(f,M.Code2,SizeOf(M.Code2),long);
            BDRCS       : LoadBDRCS(f,M,long);
            BBACK       : LoadBlock(f,M.Back,SizeOf(M.Back),long);
          else SeekAdd(f,long); {  on saute car block inconnu  }
          end;
        end;
      GestLoad := true;
    end
  else
    GestLoad:=GestFileError(191);
end;

end.
