{*****************
 *               *
 *      MEM      *
 *               *
 *****************}




{ ************* MEMORY MANAGEMENT ************ }

procedure OpenMemCompo;
var index : Word;
begin
  for index := 1 to CFG.NbreMem do new(TabMem[index]);
  For index := 0 To Cfg.NbreUndo-1 Do New(TabUndo[index]);
end;


{ ********************** ENDPROG ********************** }

Var StartDir : PathStr;   { Repertoire au dpart }

Procedure EndProg;
Var io : Word;
Begin
 If StartDir<>'' Then
  Begin
   ChDir(StartDir);    { revenir au rpertoire de dpart }
   io := IoResult;
  End;

 KeepMinitel;

 CloseInterCon;
 Mntl.Done;          { ferme l'objet }
 CloseVideoSys;

 Halt(0);
End;

{ ******************* CLAVIER **************** }


function IgnoreChange( var M : MemPg_Rec ) : boolean;
begin
  if M.Change then
    IgnoreChange := (WindError('AVERTISSEMENT',
      'L''image courante a chang','sans tre sauvegarde',
      E_IGNORE+E_ABANDON)=E_OK)
  else IgnoreChange := true;
end;

procedure GestEndProg;
  function IgnoreThisChange(mem : byte) : boolean;
  var s : string[2];
      v : string[80];
      n : string[8];
      i : word;
  begin
    str(mem-1:2,s);
    v := 'L''image ';
    if TabMem[mem]^.FileName<>'' then
      begin
        n := TabMem[mem]^.FileName;
        i := Pos('.',n);
        if i<>0 then delete(n,i,255);
        v := v+'"'+n+'" ';
      end;
    v := v+'en MEM.'+s+' a chang';

    IgnoreThisChange := WindError('AVERTISSEMENT',v,'sans tre sauvegarde',
      E_IGNORE+E_ABANDON)=E_OK;
  end;

var i : byte;
begin
  if WindError('QUITTER '+SOFTNAME,'Vous tes sr ?','',E_OUI+E_NON)
     = E_OK then
    begin
      { verifie que tout est sauvegard! }
      if not(IgnoreChange(cM^)) then exit;
      for i := 1 to CFG.NbreMem do
        if (i<>NumPage) and (TabMem[i]^.Change) and
           not(IgnoreThisChange(i)) then exit;
      EndProg;
    end;
end;



Procedure AffExtG1;
Begin
 WrtScr(' '+Hexa(CalcGraphCode(PB.graphik,TRUE))+' ',PanelGraX,PanelGraY+4,CDisp);
 If ExtG1 Then FieldAspect(131,SurEvidenceField)
 Else FieldAspect(131,CDisp);
End;


procedure AffGra;
var index,x,y : byte;
    c : Char;
    graphik : byte;
begin
  graphik := PB.graphik and 63;
  for index := 0 to 5 do
    begin
      x := PanelGraX+(index mod 2) shl 1;
      y := PanelGraY+(index shr 1);
      if (graphik and (1 shl index)) = 0 then
        begin
          WrtDt(32,x,y,CHyNet);
          WrtDt(32,x+1,y,CHyNet);
        end
      else
        begin
          If VideoEGA Then
           Begin
            WrtDt($0B,x,y,CHyNet);
            WrtDt($0C,x+1,y,CHyNet);
           End
          Else
           Begin
            WrtDt(176,x,y,CHyNet);
            WrtDt(176,x+1,y,CHyNet);
           End;
        end;
    end;
 AffExtG1;
end;

procedure AffAllAtt;
var index : byte;
begin
  for index:=0 to NbreAtt-1 do AffAtt(PB.Panel,index);
end;

procedure ClrRightZone;
var Zn : Zn_Rec;
begin
  Zn.X := 67;
  Zn.Y := 1;
  Zn.Lg := 12;
  Zn.Ht := 1;
  ClrZn(Zn,CSep);
  Zn.X := 61;
  Zn.Y := 3;
  Zn.Lg := 18;
  Zn.Ht := 21;
  ClrZn(Zn,CSep);
end;

(*
procedure ResetMinitel;
begin
  Mntl.Clear;
  Mntl.Write(#0#0+             { prepare le terrain }
             MPRO1+char($7F)+  { reset }
             MPRO1+char($67)+  { deconnexion }
             MPRO1+char($57)+  { libration de la ligne }
             MPRO1+char($7F)+  { rereset }
             #$1B#$3B#$6A#$58#$41+         { Fin du mode veille }
             MPRO3+MON+MREcran+MEPrise+    { Prise -> Ecran }
             MPRO3+MOFF+MRPrise+MEModem+   {  modem <> prise }
             MPRO3+MOFF+MRPrise+MEClavier+ { clavier <> Prise }

  {           #$1B#$23#$20#$5F+  }    { Demasquage plein cran (>M1B) }

             #31'@A'#24#12);
  repeat until Mntl.TransmitCount=0;
  delay(100);
  Mntl.ReceiveClear;          { vide le buffer recep }
end;
*)

Function FoncTas(lg : word) : Word; Far;
Begin { fin de tout ! }
 If lg>0 then FoncTas := 0;
End;


Procedure AffEchap( x, y, lg : Byte );
Const z = 'Echap pour abandonner';
Var p : Byte;
Begin
 p := CentralPos(Length(z),lg);

 WrtScr(z,x+p,y,CWind);
 AspZc(x+p,y,5,1,CRvs);
End;



{ Renvoi TRUE si on continue }

Function  SoftError( Titre, Texte1, Texte2 : String ) : Boolean;
Const X = 16; Y = 7; Lg=48; Ht=8;
Var k : Char;
    f : Boolean;
Begin
 PushZc(X,Y,Lg,Ht);

 ClrZc(X,Y,Lg,Ht,CWind);
 CCdrZc(X,Y,Lg,Ht, CdrNorm, CCadre );
 WrtScr(Titre,X+CentralPos(Length(Titre),Lg-2),Y,CChoix);

 WrtScr(CentreString(Texte1,Lg-2,32),X+1,Y+1,CHyNet);
 WrtScr(CentreString(Texte2,Lg-2,32),X+1,Y+2,CHyNet);
 WrtScr(CentreString('Tapez une touche pour continuer',Lg-2,32),X+1,Y+4,CWind);
 AffEchap(X+1,Y+6,Lg-2);

 While Not(KeyPressed) Do;

 k := ReadKey;
 f := k=#0;
 If f Then k := ReadKey;

 PopZn;

 SoftError := f Or (k<>#27);
End;



Function  InitCom : Boolean;
Begin
 InitCom := FALSE;

 If CFG.Adr=0 Then WindError('','SORTIE SERIE ("COM") INVALIDE','',E_OK)
 Else
  If CFG.Irq>15 Then WindError('','NUMERO D''IRQ INVALIDE','',E_OK)
  Else
   If Mntl.Init(CFG.Adr,CFG.Irq,TabSpeed[CFG.Speed].BD,
                EVENPARITY+DATA7BITS+STOP1BIT,
                CFG.LgIn,CFG.LgOut) Then InitCom := TRUE
   Else WindError('','IMPOSSIBLE D''OUVRIR LE PORT SERIE','',E_OK);
End;



Function  InitMouse : Boolean;
Var reg : Registers;
Begin
 InitMouse := FALSE;

 Mouse := CFG.SOURIS;
 ClavMouse := false;
 reg.AX := 0;
 IntMouse(reg);
 if reg.AX <> 0 then InitMouse := TRUE
 Else
  If SoftError('','PAS DE SOURIS DETECTEE','(Continuer avec le clavier? [Control]+[X])') Then
   Begin
    Mouse := FALSE;
    reg.AX := 0;
    IntMouse(reg);
    InitMouse := TRUE;
   End;
End;


Procedure InitMouse2;
Var reg : Registers;
Begin
 reg.AX := 0;
 IntMouse(reg); { re-init la souris ! }

 (* initialise vitesse souris *)
 reg.AX := 15;
 reg.CX := CFG.VitX;
 reg.DX := CFG.VitY;
 IntMouse(reg);
End;


Function InitMinitel : Boolean;
Const X = 12; Y = 10; Lg=56; Ht=3;
Var Res : Byte;
    NbR : Word;
Begin
 If Cfg.Silence Then InitMinitel := TRUE
 Else
  Begin
   PushZc(X,Y,Lg,Ht);

   ClrZc(X,Y,Lg,Ht,CRien);
   CCdrZc(X,Y,Lg,Ht, CdrNorm, CCadre );
   WrtScr(CentreString('Un instant ...',Lg-2,32),X+1,Y+1,CWind);

   NbR := 0;
   Repeat
    Inc(NbR);
    If MinDetect(CFG.Speed,CFG.Slow Or (NbR>2),TRUE) Then Res := 0
    Else Res := WindError('','Minitel local non prt','',E_ABANDON+E_REPRISE);
   Until Res<>E_REPRISE;

   If (Res=0) Or (Res=E_OK) Then
    Begin
     Res := 0;
     DetectTpMini;

     (*
     ResetMinitel;
     Mntl.Write(MPRO3+MOFF+MREcran+MEModem+   { Modem <> Ecran }
                MPRO3+MON+MRModem+MEPrise+    { Prise -> Modem }
                MPRO3+MON+MRPrise+MEModem     { Modem -> Prise }
               );
     *)
    End;

   PopZn;

   InitMinitel := Res=0;
  End;
End;




procedure InitSoft;
var reg : registers;
    w   : string[20];
    i   : word;
    vm  : Byte;
    io  : Word;
begin
  InstallC18;

  GetDir(0,StartDir);
  io := IoResult;
  If io<>0 Then StartDir := '';

  CheckBreak := FALSE;  (* desactive CTRL BREAK *)
  HeapError := @FoncTas;


  { Init Video }

  vm := OpenVideoSys(CFG.VMode,CFG.Neige,Cfg.Grey,Cfg.EGALight);

  If CFG.VMode=VMODE_UNDEF Then CFG.NB := vm=VMODE_MDA;

  If VideoEGA Then Colors8  { 8 couleurs seulement ! }
  Else If CFG.NB then Colors2BW;  { passage au noir & blanc!!! }

  CFG.VMode := vm;


  If InitMouse Then
   Begin
    InitMouse2;

    OpenInterCon;
    (*
    CurBig;
    CurOn;
    *)
    CurX    := 0;
    CurY    := 1;
    CurMntl := true;
    ExCurX  := 0; (* bidon *)
    ExCurY  := ScreenHigh;

    If InitCom Then
     Begin
      OpenMemCompo;

      If MemAvail>= {$IFDEF DEBUG } 16384 {$ELSE } 32768 {$ENDIF } then
       Begin
        If InitMinitel Then
         Begin
          Cfg.CZ    := Integer( (TabSpeed[Cfg.Reel].BD Div TabSpeed[Cfg.Speed].BD) -1 );
          Cfg.Delay := Word(( 25*Longint(Cfg.CZ+1)*Longint(TabSpeed[Cfg.Speed].BD) ) Div 288);

          InitRAffSystem;

          If Cfg.Silence Or MinOnLine Then DelayRAff
          Else
           Begin
            MinReset;
           End;


          Exit;


          KeepMinitel;
         End;

       End
      Else WindError('','PAS ASSEZ DE MEMOIRE','',E_OK);

      Mntl.Done;
     End;

    CloseInterCon;
   End;

  CloseVideoSys;

  Halt(1);
End;



Procedure AffChg( var M : MemPg_Rec );
Begin
 If M.Change Then WrtDt(Byte(#15 { '*' }),79,1,CNet)
 Else WrtDt(Byte(''),79,1,CSep);
End;


procedure AffUnderDisk( var M : MemPg_Rec );
var result : string[10];
    i      : byte;
begin
  result := M.FileName;
  i := pos('.',result);
  if i>0 then result[0] := char(i-1);
  result := CentreString(result,10,32);
  WrtScr(result,69,1,CNet);

  AffChg(M);
end;


procedure InitCompo;
var index : Word;
begin
  (* variable au depart *)
  for index := 0 to NbreAtt-1 do AttActif[index]:= true;
  PB.Panel  := BasePanel;
  PB.Graphik := 0;
  ExtG1   := FALSE;

  NumPage := 1; (* page MEM.0 *)
  PXhaut  := 0;
  PYhaut  := 1;
  PXbas   := ScreenLong-1;
  PYbas   := ScreenHigh-1;
  (* animation ZERO *)
  for index := 1 to CFG.NbreMem do
   Begin
    InitMemPg(TabMem[index]^);
    TabMem[index]^.UndoSerie := 0;
    TabMem[index]^.ReadSerie := 0;
   End;

  UndoRead  := 0;
  UndoWrite := 0;
  UndoNb    := 0;

  for index := 0 to CFG.NbreUndo-1 do TabUndo[index]^.Ready := FALSE;

  cM        := TabMem[NumPage];

  New(GenVD.Ram);
  New(GenVD.DRCS);

  ClearRam(GenVD.Ram);
  ClearRamDRCS(GenVD.DRCS);

  VDInUse   := FALSE;

  DRCSActif := FALSE;

  New(BackRam);
  New(BackDRCS);

{  InitParametrage(cM^); }

  Repertoire := '';
end;

Function  PresenteSoft : Boolean;
Const Tab : Array[1..3,1..28] Of VDispRamEl =
     (
      (
       (Car:#92; Att:8719), (Car:#60; Att:8719), (Car:#44; Att:8719),
       (Car:#36; Att:8719), (Car:#124; Att:8719), (Car:#60; Att:8719),
       (Car:#124; Att:8719), (Car:#52; Att:8719), (Car:#92; Att:8719),
       (Car:#48; Att:8719), (Car:#92; Att:8719), (Car:#52; Att:8719),
       (Car:#92; Att:8719), (Car:#60; Att:8719), (Car:#44; Att:8719),
       (Car:#36; Att:8719), (Car:#92; Att:8719), (Car:#60; Att:8719),
       (Car:#44; Att:8719), (Car:#36; Att:8719), (Car:#92; Att:8719),
       (Car:#60; Att:8719), (Car:#124; Att:8719), (Car:#52; Att:8719),
       (Car:#44; Att:8719), (Car:#124; Att:8719), (Car:#60; Att:8719),
       (Car:#36; Att:8719)
      ),
      (
       (Car:#95; Att:8719), (Car:#53; Att:8719), (Car:#32; Att:8719),
       (Car:#32; Att:8719), (Car:#95; Att:8719), (Car:#53; Att:8719),
       (Car:#95; Att:8719), (Car:#53; Att:8719), (Car:#95; Att:8719),
       (Car:#63; Att:8719), (Car:#95; Att:8719), (Car:#53; Att:8719),
       (Car:#95; Att:8719), (Car:#53; Att:8719), (Car:#32; Att:8719),
       (Car:#32; Att:8719), (Car:#95; Att:8719), (Car:#61; Att:8719),
       (Car:#44; Att:8719), (Car:#32; Att:8719), (Car:#95; Att:8719),
       (Car:#61; Att:8719), (Car:#47; Att:8719), (Car:#37; Att:8719),
       (Car:#32; Att:8719), (Car:#95; Att:8719), (Car:#53; Att:8719),
       (Car:#32; Att:8719)
      ),
      (
       (Car:#47; Att:8719), (Car:#45; Att:8719), (Car:#44; Att:8719),
       (Car:#36; Att:8719), (Car:#47; Att:8719), (Car:#45; Att:8719),
       (Car:#47; Att:8719), (Car:#37; Att:8719), (Car:#47; Att:8719),
       (Car:#37; Att:8719), (Car:#47; Att:8719), (Car:#37; Att:8719),
       (Car:#47; Att:8719), (Car:#45; Att:8719), (Car:#44; Att:8719),
       (Car:#36; Att:8719), (Car:#47; Att:8719), (Car:#45; Att:8719),
       (Car:#44; Att:8719), (Car:#36; Att:8719), (Car:#47; Att:8719),
       (Car:#37; Att:8719), (Car:#32; Att:8719), (Car:#32; Att:8719),
       (Car:#32; Att:8719), (Car:#47; Att:8719), (Car:#37; Att:8719),
       (Car:#32; Att:8719)
      )
     );
const Zn  : Zn_Rec = (x:16; y:6; lg:48; ht:10 );
      Con : Zn_Rec = (x:16; y:16; lg:48; ht:3);

      Inf : Zn_Rec = (x:0; y:21-1; lg:80; ht:4+1);

      Ega : Zn_Rec = (x:0; y:28; lg:80; ht:8);

const NbConf  = 7;
      ConfSep : array[1..NbConf] of byte = (5,8,4,6,6,5,6);
  procedure WrtConf(n : word; texte : string );
  var i,pos : word;
  begin
    pos := 0;
    for i := 1 to n-1 do inc(pos,ConfSep[i]+1);
    Tronque(texte,ConfSep[n]);
    WrtScr(texte,Con.x+1+pos,Con.y+1,CWind);
    if n<>NbConf then
      begin
        inc(pos,ConfSep[n]+1);
        WrtScr('',Con.x+pos,Con.y,CCadre);
        WrtScr('',Con.x+pos,Con.y+1,CCadre);
        WrtScr('',Con.x+pos,Con.y+2,CCadre);
      end;
  end;
var PY : byte;
    s  : string[20];
    a, b : Byte;
    e  : PVDispRamEl;
begin
  EmpileFld;
  PushZn(Zn);
  ClrZn(Zn,CWind);
  CCdrZn(Zn,CDRNORM,CCadre);
  If VideoEGA Then
   Begin
    For a := 1 To 3 Do
     For b := 1 To 28 Do
      Begin
       e := @Tab[a,b];
       _AffVdtChar(e^.Car,b+10-4,a+6,e^.Att);
      End;
   End
  Else
   Begin
  WrtScr(CentreString('-------------',Zn.lg-2,32),Zn.x+1,Zn.y+1,CWind);
  WrtScr(CentreString('C O N C E P T',Zn.lg-2,32),Zn.x+1,Zn.y+2,CHyNet);
  WrtScr(CentreString('-------------',Zn.lg-2,32),Zn.x+1,Zn.y+3,CWind);
   End;

  WrtScr(CentreString('Version '+VERSION,Zn.lg-2,32),Zn.x+1,Zn.y+2+2,CWind);
  WrtScr(CentreString('par '+AUTEUR+'  Copyright '+COPYRIGHT,
         Zn.lg-2,32),Zn.x+1,Zn.y+3+2,CWind);

  WrtScr(CentreString('Logiciel dans le Domaine Public',Zn.Lg-2,32),
         Zn.x+1,Zn.y+4+2+1,CWind);

  WrtScr('   OK   ',Zn.x+Zn.Lg-10,Zn.y+Zn.ht-2,CChoix);

  PushZn(Con);
  ClrZn(Con,CWind);
  CCdrZn(Con,CDRNORM,CCadre);
  s := 'COM X';
  if CFG.Com>0 then s[5] := char(byte('0')+CFG.Com);
  WrtConf(1,s);
(*
  s := 'IRQ -';
  if CFG.Irq>0 then s[5] := char(byte('0')+CFG.Irq);
  WrtConf(2,s);
  str(CFG.Adr:3,s);
  WrtConf(3,'ADR '+s);
*)
  str((115200 div TabSpeed[CFG.Speed].BD):4,s);
  WrtConf(2,s+' BDS');
  WrtConf(3,CentreString(TabTpMini[CFG.TpMini],4,32));
  str(CFG.NbreMem:2,s);
  WrtConf(4,'MEM.'+s);
  str(CFG.NbreAnn:2,s);
  WrtConf(5,'ANN.'+s);
  s := 'LPT X';
  s[5] := char(byte('1')+CFG.NumPrt);
  WrtConf(6,s);

  Str(MaxAvail Div 1024:3,s);
  WrtConf(7,s+' Ko');

  PushZn(Inf);
  ClrZn(Inf,CWind);
  CCdrZn(Inf,CDRDOUBLE,CCadre);
  WrtScr(' VERSION EN TEST ',Inf.x+1+CentralPos(17,Inf.lg-2),Inf.y,CRvs);
  WrtScr(CentreString('Signalez-moi, avec des dtails, les dfauts GENANTS que vous pourriez trouver!',Inf.lg-2,32),
         Inf.x+1,Inf.y+1,CWind);
  WrtScr(CentreString('Le D.R.C.S. n''est pas compltement utilisable.',Inf.lg-2,32),
         Inf.x+1,Inf.y+2,CWind);
  WrtScr(CentreString('(Tapez '+SOFTNAME+' /? pour savoir o et comment me contacter)',Inf.lg-2,32),
         Inf.x+1,Inf.y+2+1,CWind);


  If VideoEga Then
   Begin
    PushZn(Ega);
    ClrZn(Ega,CWind);
    CCdrZn(Ega,CDRDOUBLE,CCadre);
    If VideoVGA Then s := 'Carte VGA dtecte'
    Else s := 'Carte EGA dtecte';

    WrtScr(s,Ega.x+1+CentralPos(Length(s),Ega.lg-2),Ega.y,CRvs);

    WrtScr(#16' Pour un affichage CGA ou MDA, utilisez les options /CGA ou /MDA',
           Ega.x+1,Ega.y+1,CWind);

    If VideoVGA Then
     Begin
      WrtScr(#16' Choix [Coul/Gris] pour dsactiver/activer un affichage en couleurs',
             Ega.x+1,Ega.y+2,CWind);
     End
    Else
     Begin
      WrtScr(#16' Utilisez l''option /EGA2 pour rduire l''intensit des couleurs.',
             Ega.x+1,Ega.y+2,CWind);
     End;
    WrtScr(#16' Ni soulignement, ni clignotement visiblent',
           Ega.x+1,Ega.y+3,CWind);
    WrtScr(#16' Choix [Tl.DRCS] pour "rafrachir" l''affichage des caractres DRCS',
           Ega.x+1,Ega.y+4,CWind);
    WrtScr('  (Sur certaines configurations, ce choix peut dtriorer l''affichage...)',
           Ega.x+1,Ega.y+5,CWind);
   End;

  ChsFld(106);
  PY := PYhaut;
  PYhaut := ScreenHigh;
  repeat
  until Interaction or (Key<>'');
  PYhaut := PY;

  If VideoEga Then
   Begin
    PopZn;
   End;

  PopZn;

  PopZn;
  PopZn;
  DepileFld;

  PresenteSoft := Not((Funct And ((Key=#45) Or (Key=#16))) Or
                      (Not(Funct) And (Key=#27)));
end;

Function  InitScr : Boolean;
(* const ZnW : Zn_Rec = (x:0; y:0; lg:80; ht:25 ); *)
begin
  (*** selection du mode ecran et de la page active (0) *)
(*  ClrZn(ZnW,TNet); *)
  If PresenteSoft Then
   Begin;
    MenuGauche;
    MenuDroit;
    MenuHaut;
    MenuBas;
    InitScr := TRUE;
   End
  Else InitScr := FALSE;
end;

Function TakeAttRam( x, y : Byte ) : Word;
Begin
 With cM^.Ram[y,x] Do
  If Car=#0 then TakeAttRam := BasePanel
  Else TakeAttRam := Att;
End;

