{*****************************************************}
{                                                     }
{                        Param                        }
{                                                     }
{*****************************************************}


Procedure ConfigErreur( txt : string; nLig, nParam : Word );
Begin
 If nLig>0 Then Writeln(txt,'  ligne n',nLig,'  param.n',nParam)
 Else Writeln(txt,'   param.n',nParam);
End;



type TypeParam = string[9];


const CFGFileName : String[12] = 'CONCEPT.CFG';

      NeedHelp  : Boolean = FALSE;


      NbreParam = 37;
      ParamTab : array[1..NbreParam] of TypeParam =
                   ('NEIGE','COM1','COM2','COM3','COM4',
                    '75','300','1200','4800','9600',
                    'ENTREE','SORTIE',
                    'SAUVE','CHAINE',
                    'VER','SIL',
                    'PASSOURIS',
                    'MEM',
                    'LPT1','LPT2','LPT3',
                    'VITX','VITY',
                    'NB','COUL',
                    'MGA','MDA','CGA','EXT',
                    'SA','SR','ANN','PAUSE',
                    'EMULTRANS',
                    'IRQ','ADR',
                    'MODMNTEL' );


function TradNumber(texte : string; var nb : word) : boolean;

  procedure Hex( var nb : word; var code : integer);
  var val : longint;
      index : byte;
  begin
    val  := 0;
    for index := 2 to length(texte) do
      if (texte[index]>='0') and (texte[index]<='9') then
        val := (val*16)+(byte(texte[index])-48)
      else
        if (texte[index]>='A') and (texte[index]<='F') then
          val := (val*16)+(byte(texte[index])-55)
        else
          begin
            code := 1;
            exit;
          end;
    code := 0;
    nb := val;
  end;

var code : integer;
    x    : longint;
begin
  if texte<>'' then
    if texte[1]='$' then
      if length(texte)>1 then Hex(nb,code)
      else code := 1
    else
      begin
        Val(texte,x,code);
        if code=0 then nb := x;
      end;
  TradNumber := (code=0);
end;

Function ParamClassik( CurrentParam : String;  nLig, nParam : Word  ) : Boolean;
var index : byte;
    SecondStr : string;
    Good : boolean;
Begin
 UpCaseStr(CurrentParam);
 index := 1;
 while (index<=length(CurrentParam)) and (CurrentParam[index]<>'=') do
   inc(index);
 if index<=length(CurrentParam) then
   begin
     move(CurrentParam[index+1],SecondStr[1],length(CurrentParam)-index);
     SecondStr[0] := char(length(CurrentParam)-index);
     CurrentParam[0] := char(index-1);
   end
 else SecondStr := '';
 if CurrentParam<>'' then
   begin
     Good := false;
     for index := 1 to NbreParam do
       if CurrentParam = ParamTab[index] then
         begin
           Good := true;
           case index of
             1 : CFG.Neige := true; { NEIGE }
             2 : begin { COM1 }
                   CFG.Irq := 4;
                   CFG.Com := 1;
                 end;
             3 : begin { COM2 }
                   CFG.Irq := 3;
                   CFG.Com := 2;
                 end;
             4 : begin { COM3 }
                   CFG.Irq := 4;
                   CFG.Com := 3;
                 end;
             5 : begin { COM4 }
                   CFG.Irq := 3;
                   CFG.Com := 4;
                 end;
            6..10 : CFG.Speed := index-6; { vitesse d'execution }
            11 : Good := TradNumber(SecondStr,CFG.LgIn); { ENTREE= }
            12 : Good := TradNumber(SecondStr,CFG.LgOut); { SORTIE= }
            13 : begin { Sauve= }
                   CFG.ChSave := SecondStr;
                   AjouteAntiSlash(CFG.ChSave,sizeof(CFG.ChSave)-1);
                 end;
            14 : CFG.ChChain := SecondStr; { Chaine= }
            15 : begin { VER }
                   System.writeln(SOFTNAME+'  V'+VERSION+#10#13
                           +'par '+AUTEUR+'  Copyright '+COPYRIGHT);
                   halt(0);
                 end;
            16 : CFG.Silence := TRUE; { SIL }
            17 : CFG.SOURIS := false; { PASSOURIS }
            18 : Good := TradNumber(SecondStr,CFG.NbreMem); { MEM=1..MaxMem }
            19..21 : CFG.NumPrt := index-19; { LPT1..LPT3 }
            22 : Good := TradNumber(SecondStr,CFG.VitX); { VITX= }
            23 : Good := TradNumber(SecondStr,CFG.VitY); { VITY= }
            24 : CFG.NB := TRUE;  { NB }
            25 : CFG.NB := FALSE; { COUL }
            26,27 : { MGA ou MDA }
              begin
                CFG.VMode := VMODE_MDA;
                CFG.NB  := TRUE;
              end;
            28 : { CGA ou C80 }
              begin
                CFG.VMode := VMODE_CGA;
                CFG.NB  := FALSE;
              end;
            29 : Cfg.Ext := SecondStr;              { EXT= }
            30 : Good := TradNumber(SecondStr,MaxMouseCompteur); { SA }
            31 : Good := TradNumber(SecondStr,StepMouseDelay);   { SR }
            32 : Good := TradNumber(SecondStr,CFG.NbreAnn);   { ANN= }
            33 : CFG.PAUSE := TRUE; { PAUSE }
            34 : CFG.Emul.EmulTrans := TRUE; { TRANS }
            35 : Good := TradNumber(SecondStr,CFG.Irq);
            36 : begin
                   Good := TradNumber(SecondStr,CFG.Adr);
                   if Good then CFG.Com := 0;
                 end;
            37 : CFG.ModMntel := TRUE;
           end; { case of }
         end;
     if not(Good) then
       begin
         ConfigErreur('Erreur de syntaxe',nLig,nParam);
         (*
         write('Erreur -> ''',CurrentParam);
         if SecondStr<>'' then write('=',SecondStr);
         writeln('''');
         *)
         ParamClassik := FALSE;
         Exit;
       end;
   end;
 ParamClassik := TRUE;
End;


Type ModeParam = ( P_Rien, P_Flip, P_Egal );

     TpParam = record
         n : string[4];
         m : ModeParam;
       end;

     ParamRef = (
      _NIL,
      _SV, _CH, _EX, _ET, _ER, _EI, _EC, _MM, _OIG,
      _OIT, _OR, _ORX, _ORC, _OSG, _OST, _OST2, _OM,
      _OMC, _CSI, _CE, _VE, _FDG, _FDT, _MHB, _MBH, _MGD, _MDG,
      _MI, _MZZ, _DC, _MRM, _MRD, _FC, _SIL, _SND, _ED, _EA,
      _RC, _DIR, _BACK, _SLOW, _HELP, _RG, _IA, _REEL,
      _MDA, _CGA, _EGA, _EGA2, _VGA, _WG1, _WGP, _WCO, _WMIN, _WMAX, _WG0,
      _GRIS,
      _DERNIER
      );

Const
      TabParam : Array[Succ(_NIL)..Pred(_DERNIER)] of TpParam = (
        ( n:'SV';   m:P_Egal ),  { /SV=   sauve }
        ( n:'CH';   m:P_Egal ),  { /CH=   chaine }
        ( n:'EX';   m:P_Egal ),  { /EX=   extension }
        ( n:'E';    m:P_Flip ),  { /E+-   active/desactive l'emulation des chainages }
        ( n:'ET';   m:P_Flip ),  { /ET+-  Emulation Transparence }
        ( n:'ER';   m:P_Flip ),  { /ER+-  Emulation RTIC }
        ( n:'EI';   m:P_Flip ),  { /EI+-  Emulation d'insertion du bas (M2) }
        ( n:'EC';   m:P_Flip ),  { /EC+-  Emulation effacement du soul latent si code #15 }
        ( n:'MM';   m:P_Flip ),  { /MM+-  ModMntel }
        ( n:'OIG';  m:P_Flip ),  { /OIG+- Opt. si Invisible en Graphik }
        ( n:'OIT';  m:P_Flip ),  { /OIT+- Opt. si invisible en Texte }
        ( n:'OR';   m:P_Flip ),  { /OR+-  Opt. les rpetitions }
        ( n:'ORX';  m:P_Flip ),  { /ORX+- Opt. les rpetitions en forme }
        ( n:'OSG';  m:P_Flip ),  { /OSG+- Opt. speciale graphique }
        ( n:'OST';  m:P_Flip ),  { /OST+- Opt. speciale texte }
        ( n:'OST2'; m:P_Flip ),  { /OST2+- idem pour M2 }
        ( n:'OM';   m:P_Flip ),  { /OM+-  optimise si dj en Mem }
        ( n:'OMC';  m:P_Flip ),  { /OMC+- optimise constament si dj en Mem }
        ( n:'CSI';  m:P_Flip ),  { /CSI+- emploi des squences CSI }
        ( n:'CE';   m:P_Flip ),  { /CE+-  complement en espace }
        ( n:'VE';   m:P_Flip ),  { /VE+-  vide en espace }
        ( n:'FDG';  m:P_Flip ),  { /FDG+- force delimiteur graphique }
        ( n:'FDT';  m:P_Flip ),  { /FDT+- force delimiteur texte }
        ( n:'MHB';  m:P_Rien ),  { /MHB   mode affichage Haut bas }
        ( n:'MBH';  m:P_Rien ),  { /MBH   mode Bas haut }
        ( n:'MGD';  m:P_Rien ),  { /MGD   mode gauche  droite }
        ( n:'MDG';  m:P_Rien ),  { /MDG   mode droite  gauche }
        ( n:'MI';   m:P_Flip ),  { /MI+-  de droite  gauche }
        ( n:'MZZ';  m:P_Flip ),  { /MZZ+- en zigzag }
        ( n:'DC';   m:P_Flip ),  { /DC+-  debordement du curseur }
        ( n:'MRM';  m:P_Rien ),  { /MRM   rouleau montant }
        ( n:'MRD';  m:P_Rien ),  { /MRD   rouleau descendant }
        ( n:'FC';   m:P_Flip ),  { /FC+-  force le curseur }
        ( n:'SIL';  m:P_Flip ),  { /SIL+- silence sur la ligne... }
        ( n:'SND';  m:P_Flip ),  { /SND+- son ou pas }
        ( n:'ED';   m:P_Flip ),  { /ED+-  active ou non l'mulation DRCS }
        ( n:'EA';   m:P_Flip ),  { /EA+-  active l'emulation automatique... }
        ( n:'RC';   m:P_Flip ),  { /RC+-  autorise/interdit le code RC }
        ( n:'DIR';  m:P_Egal ),  { /DIR=  liste fichiers admis... }
        ( n:'BACK'; m:P_Flip ),  { /BACK+-crer un fichier _BACKUP_.DTI ? }
        ( n:'SLOW'; m:P_Flip ),  { /SLOW+-initialisation lente ... }
        ( n:'?';    m:P_Rien ),  { /?     demande de l'aide }
        ( n:'RG';   m:P_Flip ),  { /RG   rafraichissement global }
        ( n:'IA';   m:P_Flip ),  { /IA   introduction associ }
        ( n:'REEL'; m:P_Egal ),  { /REEL= speed (75,300,1200,4800,9600) }
        ( n:'MDA';  m:P_Rien ),  { /MDA   mono 80x25 }
        ( n:'CGA';  m:P_Rien ),  { /CGA   couleur 80x25 }
        ( n:'EGA';  m:P_Rien ),  { /EGA   ... }
        ( n:'EGA2'; m:P_Rien ),  { /EGA2  version light }
        ( n:'VGA';  m:P_Rien ),  { /VGA   ... }
        ( n:'WG1';  m:P_Flip ),  { /WG1  Watch jeux G1 }
        ( n:'WGP';  m:P_Flip ),  { /WGP  Watch jeux G'... (DRCS) }
        ( n:'WCO';  m:P_Flip ),  { /WCO  Watch COlors }
        ( n:'WMIN'; m:P_Rien ),  { /WMIN  Watch MINimum }
        ( n:'WMAX'; m:P_Rien ),  { /WMAX  Watch MAXimum }
        ( n:'WG0';  m:P_Flip ),  { /WG0  Watch jeux G0 avec RVS }
        ( n:'GRIS'; m:P_Flip )   { /GRIS vga gris ou couleurs }
        );

function FileParam( var f : text ) : boolean;
var s : string;
    r : DirStr;
    n : NameStr;
    e : ExtStr;
begin
  FileParam := TRUE;

  { recherche d'abord dans le rpertoire courant }
  Assign(f,CFGFileName);
  reset(f);
  if IoResult=0 then exit;

  { recherche dans le rpertoire o est l'executable }
  s := ParamStr(0);
  if s<>'' then
    begin
      FSplit(s,r,n,e);
      Assign(f,r+CFGFileName);
      reset(f);
      if IoResult=0 then exit;
    end;

  { recherche dans le PATH dos }
  s := FSearch(CFGFileName,GetEnv('PATH'));
  if s<>'' then
    begin
      Assign(f,s);
      reset(f);
      if IoResult=0 then exit;
    end;

  FileParam := FALSE;
end;


Function  IdenSpeed( var sp : String; Var speed : Byte ) : Boolean;
Var x : Longint;
    Err : Word;
Begin
 Val(sp,x,Err);
 If Err<>0 Then IdenSpeed := FALSE
 Else
  Begin
   IdenSpeed := TRUE;
   Case x Of
    7, 75            : speed := Speed75;
    3, 30, 300       : speed := Speed300;
    1, 12, 120, 1200 : speed := Speed1200;
    4, 48, 480, 4800 : speed := Speed4800;
    9, 96, 960, 9600 : speed := Speed9600;
   Else IdenSpeed := FALSE;
   End;
  End;
End;


Function  TraiteOption( p : TpParam; Plus : boolean; var sp : string
                      ) : String;
Var i  : word;
    t  : Word;
    Ok : Boolean;
    pr : ParamRef;
Begin
 For i := 1 To Length(p.n) Do p.n[i] := UpCase(p.n[i]);

 For pr := Succ(_NIL) To Pred(_DERNIER) Do
  If TabParam[pr].n=p.n Then
   Begin
    If (TabParam[pr].m<>p.m) And
       Not((p.m=P_Rien) And (TabParam[pr].m=P_Flip)) Then
      Begin
       TraiteOption := 'Option mal utilise';
       Exit;
      End;

    Ok := TRUE;

    Case pr Of
     _SV   :
       begin
         Cfg.ChSave := sp;                    { /SV= }
         if (Cfg.ChSave<>'') and
            (Cfg.ChSave[length(Cfg.ChSave)]<>'\') then
              begin
                inc(Cfg.ChSave[0]);
                Cfg.ChSave[length(Cfg.ChSave)] := '\';
              end;
       end;
     _CH   : Cfg.ChChain := sp;                      { /CH= }
     _EX   : Cfg.Ext := sp;                          { /EX= }
     _ET   : Cfg.Emul.EmulTrans := Plus;             { /ET+- }
     _ER   : Cfg.Emul.RTIC := Plus;                  { /ER+- }
     _EI   : Cfg.Emul.InsLowOnly := Plus;            { /EI+- }
     _EC   : Cfg.Emul.C15Clr := Plus;                { /EC+- }
     _ED   : Begin
              Cfg.EmulChDRCS := Plus;                { /ED+- }
              Cfg.EmulDRCS := Plus;
             End;
     _EA   : Cfg.EmulAuto := Plus;                   { /EA+- }
     _MM   : Cfg.ModMntel := Plus;                   { /MM+- }
     _OIG  : InitParam.OptInvGrp := Plus;            { /OIG+- }
     _OIT  : InitParam.OptInvTxt := Plus;            { /OIT+- }
     _OR   : InitParam.OptRepet := Plus;             { /OR+- }
     _ORX  : InitParam.xRep := Plus;                 { /ORX+- }
     _OSG  : InitParam.OptSpclGrp := Plus;           { /OSG+- }
     _OST  : begin
               InitParam.OptSpclTxt := Plus;         { /OST+- }
               InitParam.C15Clr     := FALSE;
             end;
     _OST2 : begin
               InitParam.OptSpclTxt := TRUE;
               InitParam.C15Clr := Plus;             { /OST2+- }
             end;
     _OM   : if Plus then InitParam.OptMem := OM_Some { /OM+- }
             else InitParam.OptMem := OM_Nothing;
     _OMC  : if Plus then InitParam.OptMem := OM_All  { /OMC+- }
             else InitParam.OptMem := OM_Some;
     _CSI  : InitParam.CSI := Plus;                  { /CSI+- }
     _CE   : InitParam.ComplAsSpace := Plus;         { /CE+- }
     _VE   : InitParam.SauteVide    := Not(Plus);    { /VE+- }
     _FDG  : InitParam.ForceDelGrp := Plus;          { /FDG+- }
     _FDT  : InitParam.ForceDelTxt := Plus;          { /FDT+- }
     _MHB  : InitParam.ModeAff := M_HautBas;         { /MHB }
     _MBH  : InitParam.ModeAff := M_BasHaut;         { /MBH }
     _MGD  : InitParam.ModeAff := M_GaucheDroite;    { /MGD }
     _MDG  : InitParam.ModeAff := M_DroiteGauche;    { /MDG }
     _MI   : InitParam.Inverse := Plus;              { /MI+- }
     _MZZ  : InitParam.ZigZag  := Plus;              { /MZZ+- }
     _DC   : InitParam.DebCursor := Plus;            { /DC+- }
     _MRM  : InitParam.ModeAff := M_Montant;         { /MRM }
     _MRD  : InitParam.ModeAff := M_Descendant;      { /MRD }
     _FC   : InitParam.ForceCur := Plus;             { /FC+- }
     _SIL  : Cfg.Silence := Plus;                    { /SIL+- }
     _SND  : Cfg.Sound   := Plus;                    { /SND+- }
     _RC   : InitParam.NoCR := Not(Plus);            { /RC+- }
     _DIR  :
      Begin                                          { /DIR= }
       ExtList := sp;
      End;
     _BACK : Cfg.BackUp := Plus;                     { /BACK+- }
     _SLOW : Cfg.Slow   := Plus;                     { /SLOW+- }
     _HELP : NeedHelp   := TRUE;                     { /? }
     _RG   : Cfg.GlobalRAff := Plus;                 { /RG }
     _IA   : Cfg.IntroRAff := Plus;                  { /IA }
     _REEL : Ok := IdenSpeed(sp,Cfg.Reel);           { /REEL= }
     _MDA  :
      Begin
       Cfg.VMode := VMODE_MDA;
       Cfg.Nb    := TRUE;
      End;
     _CGA  :
      Begin
       Cfg.VMode := VMODE_CGA;
       Cfg.Nb    := FALSE;
      End;
     _EGA  :
      Begin
       Cfg.VMode := VMODE_EGA;
       Cfg.EGALight := FALSE;
       Cfg.Nb    := FALSE;
      End;
     _EGA2 :
      Begin
       Cfg.VMode := VMODE_EGA;
       Cfg.EGALight := TRUE;
       Cfg.Nb    := FALSE;
      End;
     _VGA  :
      Begin
       Cfg.VMode := VMODE_VGA;
       Cfg.Nb    := FALSE;
      End;
     _WG1  :
      Begin
       Cfg.VAttr := Cfg.VAttr And Not(VATTR_GRAPH);
       If Plus Then Cfg.VAttr := Cfg.VAttr Or VATTR_GRAPH;
      End;
     _WGP  :
      Begin
       Cfg.VAttr := Cfg.VAttr And Not(VATTR_DRCS);
       If Plus Then Cfg.VAttr := Cfg.VAttr Or VATTR_DRCS;
      End;
     _WCO  :
      Begin
       Cfg.VAttr := Cfg.VAttr And Not(VATTR_COLORS);
       If Plus Then Cfg.VAttr := Cfg.VAttr Or VATTR_COLORS;
      End;
     _WMIN : Cfg.VAttr := 0;
     _WMAX : Cfg.VAttr := $FFFF;
     (*
      Begin
       Cfg.VAttr := 0;Cfg.VAttr And Not(VATTR_GRAPH+VATTR_DRCS+VATTR_COLORS+VATTR_RVS);
      End;
     *)
     _WG0  :
      Begin
       Cfg.VAttr := Cfg.VAttr And Not(VATTR_RVS);
       If Plus Then Cfg.VAttr := Cfg.VAttr Or VATTR_RVS;
      End;
     _GRIS : Cfg.Grey := Plus;

    Else Ok := FALSE;
    End;

    If Ok Then TraiteOption := ''
    Else TraiteOption := 'Paramtre incorrect';

    Exit;
   End;
 TraiteOption := 'Option inconnue';
End;



Function AnalyseOption( Var p : TpParam; Var Plus : Boolean; Var v : String ) : Boolean;
Var x : Word;
Begin
 If (v<>'') And ((v[1]='/') Or (v[1]='-')) Then
  Begin
   If v[Length(v)]='+' then
    Begin
     p.n  := Copy(v,2,length(v)-2);
     p.m  := P_Flip;
     v    := '';
     Plus := TRUE;
    End
   Else
    If v[Length(v)]='-' then
     Begin
      p.n  := Copy(v,2,length(v)-2);
      p.m  := P_Flip;
      v    := '';
      Plus := FALSE;
     End
    Else
     Begin
      x := Pos('=',v);
      If x=0 Then
       Begin
        p.n  := Copy(v,2,length(v)-1);
        p.m  := P_Rien;
        v    := '';
        Plus := TRUE;
       End
      Else
       Begin
        p.n  := Copy(v,2,x-2);
        p.m  := P_Egal;
        v    := Copy(v,x+1,255);
        Plus := FALSE;
       End;
     End;
   AnalyseOption := TRUE;
  End
 Else AnalyseOption := FALSE;
End;


Function TraiteParam( s : String; nLig, nParam : Word ) : Boolean;
Var p      : TpParam;
    Plus   : Boolean;
Begin
 If AnalyseOption(p,Plus,s) Then
  Begin
   s := TraiteOption(p,Plus,s);
   If s<>'' Then
    Begin
     ConfigErreur(s,nLig,nParam);
     TraiteParam := FALSE;
    End
   Else TraiteParam := TRUE;
  End
 Else TraiteParam := ParamClassik(s,nLig,nParam);
End;


Function ChargeParamLigne : Boolean;
Var nParam : Byte;
Begin
 For nParam := 1 To ParamCount Do
  Begin
   If Not(TraiteParam(ParamStr(nParam),0,nParam)) Then
    Begin
     ChargeParamLigne := FALSE;
     Exit;
    End;
  End;
 ChargeParamLigne := TRUE;
End;


Function TraiteLigne( Var Lig : String; nLig : Word ) : Boolean;
Var s      : String;
    i      : Byte;
    nParam : Word;
Begin
 nParam := 0;
 i := 1;
 While i<=Length(Lig) Do
  Begin
   If Lig[i]<>' ' Then
    Begin
     s := '';
     Repeat
      Inc(s[0]);
      s[Length(s)] := Lig[i];
      Inc(i);
     Until (i>Length(Lig)) Or (Lig[i]=' ');

     Inc(nParam);

     If Not(TraiteParam( s, nLig, nParam )) Then
      Begin
       TraiteLigne := FALSE;
       Exit;
      End;
    End
   Else Inc(i);
  End;
 TraiteLigne := TRUE;
End;


Function ChargeParamFile( Var f : Text ) : Boolean;
Var nLig : Word;
    Lig  : String;
Begin
 nLig := 0;
 While Not(Eof(f)) Do
  Begin
   Inc(nLig);
   Readln(f,Lig);
   If Lig<>'' Then
    Begin
     If Not(TraiteLigne(Lig,nLig)) Then
      Begin
       ChargeParamFile := FALSE;
       Exit;
      End;
    End
  End;
 ChargeParamFile := TRUE;
End;


Procedure Pause;
Begin
 Write('Appuyez une touche ... ');
 Asm
 @RELIT:
     MOV  AH, 08h
     INT  21h
     OR   AL, AL
     JZ   @RELIT
 End;
 Write(#13'                          '#13);
End;



Procedure ShowFastHelp;
Begin
  Writeln(SOFTNAME+'  Version '+VERSION+'  par '+AUTEUR+'  Copyright '+COPYRIGHT);
  Writeln('Logiciel dans le Domaine Public');
  Writeln;
  Writeln('---Commandes-de-configuration-(compatible version <0.60)-----------');
  Writeln(' NEIGE  inhibe "neige" sur carte CGA  | NB     force le Noir & Blanc');
  Writeln(' COUL   force la couleur              | MDA    (MGA) video hercule, mono...');
  Writeln(' CGA    video couleur: ega, vga...    | VER    affiche version');
  Writeln(' SIL    "SILence" sur la ligne com.   | PASSOURIS pas de souris');
  Writeln(' COMx   1, 2, 3 ou 4 (standard DOS)   | ADR=   adresse UART');
  Writeln(' IRQ=   nd''IRQ (attention!)          | PAUSE  simule 1200 bauds avec pause');
  Writeln(' MEM=   nombre de mmoires (max:99)   | ANN=   nombre mem.d''annulation');
  Writeln(' LPTx   1, 2 ou 3 (imprimante DOS)    | ENTREE= taille tampon entre');
  Writeln(' SORTIE= taille tampon sortie         | MODMNTEL adapte code au modem mntel');
  Writeln(' EMULTRANS emule les "transparences"  | SA=    delai d''attente souris');
  Writeln(' SR=    delai rptition souris       | VITX=  vitesse horiz. souris');
  Writeln(' VITY=  vitesse verticale souris      | SAUVE= rpertoire videotex');
  Writeln(' CHAINE= rpertoireS videotex         | EXT=   extension videotex');
  Writeln(' 75 300 1200 4800 ou 9600  vitesse du minitel local');
  Pause;
  Writeln('---Options---');
  Writeln(' /SV=   rpertoire sauvegarde videot. | /CH=   rpertoireS chainage videot.');
  Writeln(' /EX=   extension videotex            | /ET   mule transparence');
  Writeln(' /ER   mule minitel RTIC (M1B)      | /EI   mule bogue insertion (M2+)');
  Writeln(' /EC   mule bogue soulignement (M2+)| /MM   adapte code au modem minitel');
  Writeln(' /OIG   optim. si invisible graphique | /OIT  optim. si invisible texte');
  Writeln(' /OR   optim. Rptition             | /ORX  optim. Rpt. en standard');
  Writeln(' /OSG  optim. Spciale graphique     | /OST  optim. Spciale texte');
  Writeln(' /OST2 idem /OST pour M2 Philips     | /OM   optim. si dj en mmoire');
  Writeln(' /OMC  optim. constamment si en mem. | /CSI  optim. avec sq. CSI (>=M1B)');
  Writeln(' /CE   complment en espace          | /VE   vide en espace');
  Writeln(' /FDG  force dlimiteur graphique    | /FDT  force dlimiteur texte');
  Writeln(' /MHB   affichage haut->bas           | /MBH   affichage bas->haut');
  Writeln(' /MGD   affichage gauche->droite      | /MDG   affichage droite->gauche');
  Writeln(' /MI   criture inverse              | /MZZ  criture en zigzag');
  Pause;
  Writeln(' /DC   optim. avec debord. curseur   | /MRM   affichage rouleau montant');
  Writeln(' /MRD   affichage rouleau descendant  | /FC   force curseur');
  Writeln(' /SIL  silence sur la ligne...       | /SND  effet sonore');
  Writeln(' /ED   mule D.R.C.S. (>=M2)         | /EA   passage rouleau/page auto.');
  Writeln(' /RC   utilise code RC (0Dh)         | /DIR=  fichiers admis');
  Writeln(' /BACK cr un fichier _BACKUP_.DTI  | /SLOW initialisation locale lente');
  Writeln(' /RG   rafrachissement global       | /IA   introduction associe');
  Writeln(' /REEL= vitesse "rel" autre que 1200 |');
  Writeln(' /MDA   80x25 mono, hercule...        | /CGA   80x25 couleurs');
  Writeln(' /EGA   80x35 couleurs 8x10           | /VGA   80x35 coul./gris 8x10');
  Writeln(' /WG1  affichage du graphisme        | /WGP  affichage du DRCS');
  Writeln(' /WCO  affichage des couleurs/gris   | /WMIN  affichage minimun');
  Writeln(' /WMAX  affichage maximun             | /WG0  affichage du texte invers');
  Writeln(' /GRIS affichage VGA gris');
  Writeln(' /?     un peu d''aide');
  Writeln;
  Writeln('Fichier de configuration: '+CFGFileName);
  Pause;
  Writeln(#10#10#10#10#10);
  Writeln('Ŀ');
  Writeln('Le logiciel "Concept" version 0.60 25 (bta 25) est dans le Domaine Public.');
  Writeln('Ce logiciel et sa documentation ne peuvent pas faire l''objet d''une          ');
  Writeln('transaction commerciale.                                                    ');
  Writeln('Ils peuvent tre copis et utiliss sans restriction, cependant ils ne      ');
  Writeln('doivent pas tre modifis.                                                  ');
  Writeln('L''auteur ne peut pas tre tenu responsable de dommages directs ou indirects ');
  Writeln('dcoulant de l''utilisation de ce logiciel.                                  ');
  Writeln('Tous droits rservs.                                                       ');
  Writeln('Copyright (c) 1988-92  T.JAOUEN                                             ');
  Writeln('Ĵ');
  Writeln('Vous pouvez contacter l''auteur par minitel:                                 ');
  Writeln('  tel.: 3614    code du service: TEASER     boite aux lettres: LOGICOS      ');
  Writeln('');
  Writeln(#10#10#10#10);
End;


Procedure ChargeParam;
Var f : Text;
begin
  If ParamStr(1)='/?' Then
   Begin
    ShowFastHelp;
    Halt(0);
   End;

  ExtList := '';

  If FileParam(f) Then
   Begin
    If Not(ChargeParamFile(f)) Then
     Begin
      Close(f);
      Halt(1);
      Exit;
     End;

    Close(f);
   End;

  If ChargeParamLigne Then
   Begin
    If NeedHelp Then
     Begin
      ShowFastHelp;
      Halt(0);
     End;

    if CFG.Com>0 then CFG.Adr := memw[$40:$00+(CFG.Com-1)*2];
    if CFG.NbreMem<1 then CFG.NbreMem := 1
    else
      if CFG.NbreMem>MaxMem then CFG.NbreMem := MaxMem;
    if CFG.NbreAnn<1 then CFG.NbreAnn := 1
    else
      begin
        if CFG.NbreAnn>MaxAnn then CFG.NbreAnn := MaxAnn;
        if CFG.NbreAnn>CFG.NbreMem then CFG.NbreAnn := CFG.NbreMem;
      end;
    if CFG.LgIn>8192 then CFG.LgIn := 8192;
    if CFG.LgOut>16384 then CFG.LgOut := 16384;
    CFG.NbreUndo := CFG.NbreAnn*ScreenHigh;
   End
  Else Halt(1);
end;



procedure AjouteAntiSlash( var s : string; max : byte );
begin
  if (s<>'') and (length(s)<max) and (s[length(s)]<>'\') then s := s+'\';
end;
