{$A+,B-,E-,F-,G-,I-,N-,O-,V-,X- }

{$IFDEF DEBUG }
  {$R+,S+ }
{$ELSE }
  {$D-,L-,R-,S- }
{$ENDIF }

Unit DirCon;

interface

uses Dos,Crt,VdtTools,Colors,Video60,Stringer,InterCon,error;

{ ****************** DISK ******************** }

type string12 = string[12];
var Repertoire : DirStr;
    ExtList    : String;

const
(*
     DriveError : word = 0;
     DriveAbandon : boolean = false;
*)
     HautWindDir = 11;
     ZnDir : Zn_Rec = (x:17; y:0; lg:46; ht:25 ); {  point de depart dessin  }

procedure CorrectorFileName(var name : string);
procedure ResetDirWind( var M : MemPg_Rec );
function DiskWind( Ybas : byte) : boolean;
function DirWindChoix( var M : MemPg_Rec ) : boolean;
procedure DisposeDir;
function GestWindError(TypeError,numError,Gadget : byte):byte;

implementation

{ ******************* INCLUSION DIRECT ****************** }

type
     dir_map = record
                 att   : byte;
                 instant : LongInt;
                 long  : LongInt;
                 nom   : string[12];
               end;

var  DirInfo : SearchRec;

function Dir(var fichier : dir_map; var InitDir : boolean) : boolean;
begin
  if InitDir then
    begin
      InitDir := false;
      FindFirst(fichier.nom,fichier.att,DirInfo);
    end
  else FindNext(DirInfo);
  if DosError<>0 then
    begin {  ERROR  }
      fichier.att := DosError;
      if fichier.att = 18 then fichier.att := 0;
      Dir := false;
    end
  else
    begin
      Dir := true;
      move(DirInfo.Attr,fichier.att,SizeOf(dir_map));
    end;
end;

function ExtracInstant(instant : LongInt; seconde : boolean; century : boolean)
                 : string;
var What : DateTime;
    ch   : string[4];
    date : string[10];
    heure : string[8];
begin
  UnPackTime(instant,What);
  str(What.Day:2,ch);
  date := ch;
  str(What.Month:2,ch);
  date := date+'/'+ch;
  if century then str(What.Year:4,ch)
  else str((What.Year-1900):2,ch);
  date := date+'/'+ch;
  ChangeData(date,32,48); {  change les espaces en Zero  }
  if instant and 65535=0 then heure := '     '
  else
    begin
      str(What.Hour:2,ch);
      heure := ch;
      str(What.Min:2,ch);
      heure := heure+':'+ch;
      if seconde then
        begin
          str(What.Sec:2,ch);
          heure := heure+':'+ch;
        end;
      ChangeData(heure,32,48);
    end;
  ExtracInstant := Date+'  '+heure;
end;

function ExtracLong(long : LongInt) : string;
var texte : string[7];
begin
  str(long:7,texte);
  ExtracLong := texte;
end;

procedure FormeNom(var nom : string; att : byte; ShowPoint : boolean);
{  c'est obligatoirement le nom d'un fichier dont le format est :  }
{  NOMFICHE.EXT et est issue directement d'une saisie Dir  }
{  les NOMFICHE sans ext sont accepte (dir)  }
{  ShowPoint : indic si un point doit separer nom et ext  }
var final : string[12];
    LongFinal : byte absolute final;
    index : byte;
begin
  if (att and (Directory+VolumeID))<>0 then
    {  dans ce cas, on complete juste pour une longueur de 12  }
    begin
      if (att and VolumeID)<>0 then
        begin {  on vire le '.'  }
          index := pos('.',nom);
          if index<>0 then delete(nom,index,1);
        end;
      final := nom;
    end
  else
    begin
      index := pos('.',nom);
      if index<>0 then
        begin
          final := copy(nom,1,index-1);
          while LongFinal<8 do
            begin
              Inc(LongFinal);
              final[LongFinal] := ' ';
            end;
          LongFinal := 9;
          if ShowPoint then final[9]:='.' else final[9]:=' ';
          final := final+copy(nom,index+1,length(nom)-index);
        end
      else final := nom;
    end;
  while LongFinal<12 do
    begin
      Inc(LongFinal);
      final[LongFinal] := ' ';
    end;
  nom := final;
end;

{ ******************** GESTION DE DirList ******************** }

const
      MaxDirList = 1024;   {   au lieu de 512 pour ver<0.60B21   }
type pdir_map = ^dir_map;
var
     DirList : array [1..MaxDirList] of pdir_map;
     LongDirList  : Integer;
     LabelDisk    : dir_map;
     LabelExist   : boolean;
     LevelDirList : integer;

procedure DisposeDir;
{  c'est LongDirList qui definit le nombre de mmoire a liberer!!  }
{  si LongDirList=0 alors RIEN  liberer  }
var i : word;
begin
  for i := LongDirList downto 1 do dispose(DirList[i]);
  LongDirList := 0;
end;

procedure SearchAndPos( name : string;
                        var Top : word;
                        var PosEgal : word );
var index,level : integer;
    Actuel : string[8];
    EndBoucle : boolean;
begin
  if name<>'' then
    begin
      {  on recherche le nom du fichier dans la liste  }
      FormeNom(name,Archive,false);
      UpCaseStr(name);
      Tronque(name,8);
      index := 1;
      EndBoucle := false;
      while (index<=LongDirList) and (not(EndBoucle)) do
        begin
            Actuel := DirList[index]^.nom;
            if Actuel<name then Inc(index)
            else EndBoucle := true;
        end;
      if Actuel<>name then PosEgal := 0
      else PosEgal := index;
      level := index;
      index := (LongDirList-HautWindDir)+1;
      if index<=0 then index := 1;
      Dec(Level,(HautWindDir div 2));
      if level<=0 then level := 1
      else
        if Level>index then Level := index;
      Top := level;
    end
  else
    begin
      Top := 1;
      PosEgal := 0;
    end;
end;

procedure quick(gauche,droite : word);
var i,j   : word;
    pivot : pdir_map;
    tempo : pdir_map;
begin
  i := gauche;
  j := droite;
  pivot := DirList[(gauche+droite) div 2];
  repeat
    while DirList[i]^.nom<pivot^.nom do Inc(i);
    while DirList[j]^.nom>pivot^.nom do Dec(j);
    if i<=j then
      begin
      tempo := DirList[i];
      DirList[i] := DirList[j];
      DirList[j] := tempo;
      Inc(i);
      Dec(j);
      end;
  until i>j;
  if j>gauche then quick(gauche,j);
  if i<droite then quick(i,droite);
end;

function GestWindError(TypeError,numError,Gadget : byte):byte;
var error,msg1,msg2 : string;
procedure NoSol;
begin
  msg1 := 'CODE ERREUR NON TRAITE';
  str(numError:3,msg2);
  msg2 := '('+msg2+')';
end;

begin
  error := '';
  msg1 := '';
  msg2 := '';
  if (Gadget and 7)=0 then Gadget := E_OK;
  if numError = 0 then error := 'BOGUE'
  else
    begin
      case TypeError of
        1 : begin {  ERREUR CRITIQUE  }
              error := 'ERREUR CRITIQUE';
              case numError of
                2 : msg1 := 'REPERTOIRE TROP GRAND';
              else NoSol;
              end;
            end;
        2 : begin
  if (numError>=1) and (numError<=99) then
    begin
      error := 'ERREUR DOS';
      msg1 := MsgError(numError);
    end
  else
    if (numError>=100) and (numError<=149) then
      begin
        error := 'ERREUR D''ENTREE/SORTIE';
        case numError of
          130 : msg1 := 'IMPRIMANTE NON PRETE';
          131 : msg1 := 'IMPRESSION INTERROMPUE';
         else msg1 := MsgError(numError);
        end;
      end
    else
      if (numError>=150) and (numError<=189) then
        begin
          error := 'ERREUR CRITIQUE';
          msg1 := MsgError(numError);
        end
      else
        if (numError>=190) and (numError<=255) then
          begin
            error := 'ERREUR DISQUE';
            case numError of
            {  erreur interne prog  }
              190 : msg1 := 'FICHIER SANS NOM';
              191 : msg1 := 'FORMAT DE FICHIER NON RECONNU';
              202 : msg1 := 'FICHIER ''COMMAND.COM'' INTROUVABLE';
            else NoSol;
            end; {  case of  }
          end;
            end; {  erreur type : 2  }
      else
        begin
          error := 'ERREUR NON TYPEE';
          NoSol;
        end;
      end;
    end;
  GestWindError := WindError(error,msg1,msg2,Gadget);
end;


Function StrComp( Var Refer : String; Var Sujet : String; MinMaj : Boolean ) : Integer; Assembler;
Asm
        push ds

        lds  si, [Refer]
        les  di, [Sujet]
        mov  cl, [ds:si]        { cl=length(Refer) }
        mov  ch, [es:di]        { ch=length(Sujet) }
        inc  si
        inc  di

        cld
        or   cl, cl
        jz   @FINBOUCLE
@BOUCLE:
        lodsb
        cmp  al, '*'
        je   @EGAL              { fin trouv '*' }
        or   ch, ch
        jz   @SUP               { fin +1 }
        cmp  al, '?'
        je   @NEXT
        mov  ah, [es:di]
        cmp  [MinMaj], 0
        jne  @ICI_02            { Branch si on respecte les Min/Maj }
        cmp  al, 'a'
        jb   @ICI_01
        cmp  al, 'z'
        ja   @ICI_01
        sub  al, 32             { -32! }
@ICI_01:
        cmp  ah, 'a'
        jb   @ICI_02
        cmp  ah, 'z'
        ja   @ICI_02
        sub  ah, 32             { -32! }
@ICI_02:
        cmp  al, ah
        ja   @SUP
        jb   @INF
@NEXT:
        inc  di
        dec  ch
        dec  cl
        jnz  @BOUCLE
@FINBOUCLE:
        cmp  ch, cl
        ja   @INF
@EGAL:
        mov  ax, 0              { Egal! }
        jmp  @FIN
@INF:
        mov  ax, -1             { inferieur! }
        jmp  @FIN
@SUP:
        mov  ax, +1             { superieur }
@FIN:
        pop  ds
End;



Function StrPosChar( Var s : String; pos : Integer; c : Char ) : Word; Assembler;
Asm
        mov  bx, [pos]
        or   bx, bx
        jnle @LA
        xor  ax, ax          { renvoi 0 }
        jmp  @RET
@LA:
        push ds

        lds  si, [s]
        cld
        mov  cl, [si]        { longueur chaine }
        xor  ch, ch
        cmp  bx, cx
        jbe  @ICI
        { bx trop grand }
        xor  ax, ax          { renvoi 0 }
        jmp  @FIN
@ICI:
        sub  cx, bx
        inc  cx
        add  si, bx
        mov  ah, [c]
@BOUCLE:
        lodsb
        cmp  al, ah
        loopne @BOUCLE
        je   @OK
        { non egal }
        xor  ax, ax          { renvoi 0 }
        jmp  @FIN
@OK:
        mov  ax, si
        mov  si, [WORD PTR s]
        sub  ax, si
        dec  ax              { renvoi pos<>0 }
@FIN:
        pop  ds
@RET:
End;


Procedure StrPlaneRight( var s: String ); Assembler;
Asm
        push ds

        lds  si, [s]
        mov  cl, [si]
        xor  ch, ch
        jcxz @FIN        { c'est vide ! }

        add  si, cx
        std              { en sens inverse ici }
@BOUCLE:
        lodsb
        cmp  al, ' '
        jne  @ICI
        loop @BOUCLE     { boucle tant qu'il y a des espaces }
@ICI:
        mov  si, [WORD PTR s]   { recharge uniquement l'offset }
        mov  [si], cl           { et hop ! }

@FIN:
        pop  ds
End;


var
     NbreFile    : word; {  fichier et non directory!  }
     NbreFileDTI : word; {  nbre de fichier data concept  }
     NbreFileVDT : word; {  nbre de fichier videotex  }
     NbreDir     : word; {  nbre de directory  }
     FreeOctets  : LongInt;

function ExtVDT( var nom : string) : boolean;
var Ext : string[3];
begin
  move(nom[10],Ext[1],3);
  Ext[0] := #3;
  ExtVdt := (Ext='VDT')or(Ext=Cfg.Ext)or(Ext='VDX')or(Ext='VTX');
end;

function ExtDTI( var nom : string) : boolean;
var Ext : string[3];
begin
  move(nom[10],Ext[1],3);
  Ext[0] := #3;
  ExtDTI := (Ext='DTI');
end;

Function ExtXXX( var nom : String ) : Boolean;
Var iRead : Byte;
    s     : NameStr;
    e     : Byte;
    lg    : Byte;
    r     : DirStr;
    name  : NameStr;
    Ext   : ExtStr;
    n0    : NameStr;
    e0    : ExtStr;
Begin
 n0 := Copy(nom,1,8);
 StrPlaneRight(n0);
 e0 := Copy(nom,10,3);
 StrPlaneRight(e0);
 iRead := 1;
 Repeat
  e := StrPosChar(ExtList,iRead,';');
  If e=0 Then lg := (length(ExtList)+1)-iRead
  Else lg := e-iRead;
  s := Copy(ExtList,iRead,lg);
  FSplit(s,r,name,ext);
  delete(ext,1,1);
  If (StrComp(name,n0,FALSE)=0) And
     (StrComp(ext,e0,FALSE)=0) Then
   Begin
    ExtXXX := TRUE;
    Exit;
   End;
  iRead := e+1;
 Until e=0;
 ExtXXX := FALSE;
End;

const D_VDT = 64;
      D_DTI = 128;

function WindGetDir(NumDisk : byte; var Rep : string) : boolean;
var io : word;
begin
  GetDir(NumDisk,Rep);
  io := IOResult;
  if io = 0 then WindGetDir := true
  else
    begin
      io := GestWindError(2,io,E_OK);
      WindGetDir := false;
    end;
end;

function ResetDir : boolean;
{  va recherche le repertoire et des informations sur le disk  }
var GetLabel : boolean;
    FirstDir : boolean;
    fichier  : dir_map;
    Critik   : boolean; { indique si une err critique  eu lieu... }
    p        : pdir_map;
    n        : word;
    AddIt    : Boolean;
begin
  if WindGetDir(0,Repertoire) then
    begin
      Critik := FALSE;
      ResetDir := true;
      DisposeDir; {  libere la mmoire dynamique dja allou  }

      GetLabel := true;
      LabelExist := false;
      LongDirList := 0;

      FreeOctets := DiskFree(0); {  dans toutes les situations  }
      FirstDir := true;
      fichier.nom := '*.*';
      fichier.att := ReadOnly+VolumeID+Directory+Archive;
      NbreFile    := 0;
      NbreFileVDT := 0;
      NbreFileDTI := 0;
      NbreDir     := 0;
      while not(Critik) and Dir(fichier,FirstDir) do
        begin
          FormeNom(fichier.nom,fichier.att,false);
          if ((fichier.att and VolumeID)<>0) then
            begin
              if GetLabel then
                begin
                  LabelDisk := fichier;
                  LabelExist := true;
                  GetLabel := false;
                end;
            end
          else
            begin
              AddIt := FALSE;
              fichier.att := fichier.att and 63;
              if fichier.att=0 then fichier.att := Archive;
              if (fichier.att and Archive)<>0 then
               begin
                if ExtDTI(fichier.nom) then
                  begin
                    fichier.att := fichier.att or D_DTI; {  indic data img  }
                    Inc(NbreFileDTI);
                    Inc(NbreFile);
                    AddIt := TRUE;
                  end
                else
                  if ExtVDT(fichier.nom) then
                    begin
                      fichier.att := fichier.att or D_VDT; {  indic videotex  }
                      Inc(NbreFileVDT);
                      Inc(NbreFile);
                      AddIt := TRUE;
                    end
                  Else
                   If (ExtList<>'') And (ExtXXX(fichier.nom)) Then
                    Begin
                     Inc(NbreFile);
                     AddIt := TRUE;
                    End;
               end
              else
                if (fichier.att and Directory)<>0 then
                 Begin
                  If fichier.nom<>'.           ' Then
                   Begin
                    Inc(NbreDir);
                    AddIt := TRUE;
                   End;
                 End;

              If AddIt Then
               if LongDirList<MaxDirList then
                begin
                 new(p);
                 p^ := fichier;
                 Inc(LongDirList);
                 DirList[LongDirList] := p;
                end
               else
                begin
                 n := GestWindError(1,2,E_OK); { rep trop grand! }
                 Critik := TRUE;
                end;
            end;
        end;
        if not(Critik) and (fichier.att<>0) then {  error!  }
          begin
            fichier.att := GestWindError(2,fichier.att,E_OK);
            ResetDir := false;
          end
        else
         If LongDirList>0 Then quick(1,LongDirList); {  trie rapide  }
    end
  else
    ResetDir := false;
end;

{ ********************* WIND DISK ********************** }



procedure AffFile(fichier : dir_map; pos : byte);
var buf_texte : string[38];
    Att : byte;
begin
    if fichier.att = 255 then
      begin
        buf_texte := FillString(38,32);
        att := TNoNet;
      end
    else
      begin
        buf_texte := ExtracInstant(fichier.instant,false,false);
        if (fichier.att and Directory)<>0 then
          begin
            buf_texte := fichier.nom+' <REP>     '+buf_texte;
            att := TMiNet;
          end
        else
          begin
            buf_texte := fichier.nom+'  '+ExtracLong(fichier.long)+
                         '  '+buf_texte;
            if (fichier.att and D_DTI)<>0 then att := TNet
            else
              if (fichier.att and D_VDT)<>0 then att := TMiNet
              else att := TNoNet;
          end;
      end;
  WrtScr(buf_texte,ZnDir.X+2,ZnDir.Y+1+pos,att);
end;

procedure ClrLeftList;
var index : byte;
begin
  for index := 1 to HautWindDir do WrtDt(32,Zndir.X+1,Zndir.y+1+index,CWind);
end;

procedure AffList(debut : integer; EvidPos : word);
const empty : dir_map = ( att : 255; instant : 0; long : 0;
                          nom : '            ');
var index : integer;
    Border : byte;
begin
  {  on eteind un champs actif dans la presente liste  }
  if (inter.FieldEcran<>0) and ((inter.SelectField>=55) and (inter.SelectField<=76))
    then FieldOff;
  for index := 1 to HautWindDir do
    begin
      if (EvidPos = (debut+index-1)) then border := 16 else border := 32;
      WrtDt(border,ZnDir.X+1,ZnDir.Y+1+index,CWind);
      if (debut+index-1)<=(LongDirList) then
        AffFile(DirList[debut+index-1]^,index)
      else
        AffFile(empty,index);
    end;
end;

procedure AffInChamp( var texte : string; lg_chp,col,ligne : integer);
var buf : string;
    pos : integer;
begin
  FillChar(buf[1],lg_chp,32);
  buf[0] := char(lg_chp);
  pos := length(texte)-lg_chp+1;
  if pos<0 then pos := 0;
  move(texte[pos+1],buf[1],length(texte)-pos);
  WrtScr(buf,col,ligne,TNet);
end;


procedure AffExtList( var ExtList : string);
begin
  AffInChamp(ExtList,42,Zndir.X+2,Zndir.y+14);
end;

procedure AffRep( var rep : string);
begin
  AffInChamp(rep,42,Zndir.X+2,Zndir.y+16);
end;

procedure AffFileName( var name : string);
begin
  AffInChamp(name,42,Zndir.x+2,Zndir.y+18);
end;

function DiskWind( Ybas : byte) : boolean;
const Tab : array[1..13] of string[3] = (
            ' '#9' ','͸','',' '#24' ',#24#24#24,
            'Ŀ','͵','',#25#25#25,' '#25' ',
            'Ŀ',';',' ? ' );
      TabEga : array[1..13] of string[3] = (
            ' '#9' ','͸','',' '#$1E' ',#$1E#$1E#$1E,
            'Ŀ','͵','',#$1F#$1F#$1F,' '#$1F' ',
            'Ŀ',';',' ? ' );
var index : byte;
    Zn : Zn_Rec;
begin
  ZnDir.Ht := (Ybas+1)-ZnDir.Y;
  PushZn(ZnDir);
  ClrZn(ZnDir,CWind);
  CCdrZn(ZnDir,CDRNORM,CCadre);
  Zn.x := ZnDir.x+2;
  Zn.y := ZnDir.y+2;
  Zn.lg := 38;
  Zn.Ht := HautWindDir;
  ClrZn(Zn,TNet);

  If VideoEga Then
    for index := 1 to 13 do WrtScr(TabEga[index],Zndir.X+41,Zndir.y+index,CChoix)
  Else
    for index := 1 to 13 do WrtScr(Tab[index],Zndir.X+41,Zndir.y+index,CChoix);

  WrtScr('Fichiers admis: (*.DTI;*.VDT;...)',Zndir.x+2,Zndir.y+13,FWind+TMiNet);
  WrtScr(FillString(42,32),Zndir.x+2,ZnDir.y+14,TNet);
  WrtScr('Rpertoire:',Zndir.x+2,Zndir.y+15,FWind+TMiNet);
  WrtScr(FillString(42,32),Zndir.x+2,ZnDir.y+16,TNet);
  WrtScr('Fichier:',Zndir.x+2,Zndir.y+17,FWind+TMiNet);
  WrtScr(FillString(42,32),Zndir.x+2,ZnDir.y+18,TNet);
  LongDirList := 0; {  !!! ATTENTION !!!  }
  DiskWind := ResetDir; {  en cas d'abandon a la suite d'une erreur!  }
end;

procedure ResetDirWind( var M : MemPg_Rec );
var EvidPos : word;
begin
  SearchAndPos(M.FileName,word(LevelDirList),EvidPos);
  AffList(LevelDirList,EvidPos);
  AffExtList(ExtList);
  AffRep(repertoire);
  AffFileName(M.FileName);
end;

procedure ListDown(nbre : byte);
begin
  LevelDirList := LevelDirList-nbre;
  if LevelDirList<=0 then LevelDirList := 1;
  AffList(LevelDirList,0);
end;

procedure ListUp(nbre : byte);
var tempo : integer;
begin
  tempo := (LongDirList-HautWindDir)+1;
  if tempo<=0 then tempo := 1;
  LevelDirList := LevelDirList+nbre;
  if LevelDirList>tempo then LevelDirList := tempo;
  AffList(levelDirList,0);
end;

function WindChDir(Rep : string): boolean;
var io : word;
begin
  ChDir(Rep);
  io := IOResult;
  if io = 0 then WindChDir := true
  else
    begin
      io := GestWindError(2,io,E_OK);
      WindChDir := false;
    end;
end;

procedure ChangeDir;
{  en repertoire  }
var bidon : byte;
begin
  if WindChDir(repertoire) then
    if ResetDir then
      begin
        LevelDirList := 1;
        AffList(1,0);
      end;
  bidon := byte(WindGetDir(0,repertoire));
  AffRep(repertoire);
end;

procedure GestListChoix(var M : MemPg_Rec; fichier : dir_map);
begin
  if (fichier.att and Directory)<>0 then
    begin
      KillData(fichier.nom,32);
      if length(repertoire)>3 then
        repertoire := repertoire+'\'+fichier.nom
      else
        repertoire := repertoire+fichier.nom;
      ChangeDir;
    end
  else
    begin {  pour File  }
      fichier.nom[9] := '.';
      KillData(fichier.nom,32);
      M.FileName := fichier.nom;
      AffFileName(M.FileName);
      ClrLeftList;
    end;
end;

procedure InfoOnDisk;
const Zn : Zn_Rec = (X:25; Y:3; lg:29; ht:9 );
      Tab : array[1..6] of string[15] =
            ('        Label: ','Octets libres: ',' Fichiers DTI: ',
             'Fich.Videotex: ','  Rpertoires: ','Tous fichiers: ');
var buf : string[30];
    index : byte;
  procedure WritePro(nbre : word; pos : byte);
  begin
    Str(nbre:5,buf); KillData(buf,32);
    WrtScr(buf,Zn.X+16,Zn.Y+pos,FWind+TNet);
  end;
begin
  EmpileFld;
  PushZn(Zn);
  ChsFld(77);
  ClrZn(Zn,CWind);
  CCdrZn(Zn,CDRNORM,CCadre);
  for index := 1 to 6 do WrtScr(Tab[index],Zn.X+1,Zn.Y+index,FWind+TMiNet);
  WrtScr('   OK   ',Zn.X+19,Zn.Y+7,CChoix);
  if LabelExist then
    begin
      WrtScr(LabelDisk.nom,Zn.X+16,Zn.Y+1,FWind+TNet);
    end;
  Str(FreeOctets:10,buf); KillData(buf,32);
  WrtScr(buf,Zn.X+16,Zn.Y+2,FWind+TNet);
  WritePro(NbreFileDTI,3);
  WritePro(NbreFileVDT,4);
  WritePro(NbreDir,5);
  WritePro(NbreFile,6);
  repeat
  until (Interaction and (Key=#0)) Or (Not(Funct) And ((Key=#27) Or (Key=#13)));
  PopZn;
  DepileFld;
end;

procedure CorrectorFileName(var name : string);
var index : byte;
    nom   : string[8];
    suf   : string[3];
begin
  KillData(name,32);
  index:=Pos('.',name);
  if index = 0 then
    begin
      index := length(name)+1;
      suf := '';
    end
  else
    begin
      suf := copy(name,index+1,length(name)-index);
    end;
  nom := copy(name,1,index-1); {  coupe a 8 si hors limite  }
  if nom<>'' then
    begin
      name := nom;
      if suf<>'' then name := name+'.'+suf;
    end
  else name := '';
  UpCaseStr(name);
end;

procedure ChangeFileName( var M : MemPg_Rec );
var EvidPos : word;
begin
  CorrectorFileName(M.FileName);
  AffFileName(M.FileName);
  SearchAndPos(M.FileName,word(LevelDirList),EvidPos);
  AffList(LevelDirList,EvidPos);
end;

function DirWindChoix( var M : MemPg_Rec ) : boolean;

  procedure extlist_saisie;
  var s : string;
      pos : word;
  begin
    s := ExtList;
    pos := 256;
    if InputString(s,pos,sizeof(ExtList)-1,42,Zndir.X+2,Zndir.y+14) then
      begin
        KillData(s,32);
        UpCaseStr(s);
        ExtList := s;
        AffExtList(ExtList);
        ChangeDir;
      end
    else AffExtList(ExtList);
  end;

  procedure rep_saisie;
  var s : string;
      pos : word;
  begin
    s := repertoire;
    pos := 256;
    if InputString(s,pos,sizeof(repertoire)-1,42,Zndir.X+2,Zndir.y+16) then
      begin
        KillData(s,32);
        UpCaseStr(s);
        repertoire := s;
        AffRep(repertoire);
        ChangeDir;
      end
    else
      AffRep(repertoire);
  end;
  procedure file_saisie;
  var s : string;
      pos : word;
  begin
    s := M.FileName;
    pos := 256;
    if InputString(s,pos,sizeof(M.FileName)-1,42,Zndir.x+2,Zndir.y+18) then
      begin
        KillData(s,32);
        UpCaseStr(s);
        M.FileName := s;
        AffFileName(M.FileName);
        ChangeFileName(M);
      end
    else AffFileName(M.FileName);
  end;
var bidon : integer;
begin
  DirWindChoix := true;
  case inter.SelectField of
    44 : InfoOnDisk;
    45 : if ResetDir then ResetDirWind(M);
    46 : begin {  debut  }
           LevelDirList := 1;
           AffList(1,0);
         end;
    47 : ListDown(1);
    48 : ListDown((HautWindDir div 2)+1);
    49 : begin {  milieu  }
           LevelDirList := ((LongDirList+1)-HautWindDir) div 2;
           if LevelDirList<=0 then LevelDirList := 1;
           AffList(LevelDirList,0);
         end;
    50 : ListUp((HautWindDir div 2)+1);
    51 : ListUp(1);
    52 : begin {  fin  }
           LevelDirList := (LongDirList+1)-HautWindDir;
           if LevelDirList<=0 then LevelDirList := 1;
           AffList(LevelDirList,0);
         end;
    139 : Begin { ExtList }
           FieldOff;
           extlist_saisie;
          End;
    53 : begin {  rep  }
           FieldOff;
           rep_saisie;
         end;
    54 : begin {  fich  }
           FieldOff;
           file_saisie;
         end;
    55..76 : if inter.SelectField<(55+HautWindDir) then
               begin
                 bidon := (inter.SelectField-55)+LevelDirList;
                 if bidon<=LongDirList then
                   GestListChoix(M,DirList[bidon]^);
               end;
    else DirWindChoix := false;
  end;
end;

end.
